<%

Const cCardEllipsis = 100

Function ViewCardBrief(rec,bLongView,btn1,btn2,btn3,btn4,AddDisplayText)
    %>
    <table width="100%" class="cardPreview" cellpadding="1" cellspacing="0">
        <tr>
            <td valign="top" nowrap class="cardPreviewCardId">
                <%= HTMLEncode(rec("CARD_NUMBER")) %><br/>
                <%= TR("Object") & ": " & HTMLEncode(rec("OBJECT_NUMBER")) %>
            </td>
            <td valign="top" nowrap class="cardPreviewButtons" colspan="3">
                <%
                    If IsObject(btn1) Then btn1.RenderValue(rec("SID"))
                    If IsObject(btn2) Then btn2.RenderValue(rec("SID"))
                    If IsObject(btn3) Then btn3.RenderValue(rec("SID"))
                    If IsObject(btn4) Then btn4.RenderValue(rec("SID"))
                %>
            </td>
        <tr>
        <% If Len(AddDisplayText) > 0 Then %>
        <tr>
            <td valign="top" nowrap class="cardPreview" colspan="4"><strong><%= AddDisplayText %></strong></td>
        <tr>
        <% End If %>
        <tr>
            <td valign="top" nowrap class="cardPreview"><%= TR("Location") %></td>
            <td valign="top" class="cardPreviewContent"><%= HTMLEncode(GetLocation(rec("LOCATION_SID")).FullName) %></td>
            <td valign="top" nowrap class="cardPreview"><%= TR("Location description") %></td>
            <td valign="top" class="cardPreviewContent"><%= HTMLEncode(rec("PLACE_ADDRESS")) %></td>
        <tr>
        <tr>
            <td valign="top" nowrap class="cardPreview"><%= TR("Ownership") %></td>
            <td valign="top" class="cardPreviewContent"><%= Nomenclature("OWNERSHIP",rec("OWNERSHIP_SID")).Name %></td>
            <td valign="top" nowrap class="cardPreview"><%= TR("Terrain usage") %></td>
            <td valign="top" class="cardPreviewContent"><%= Nomenclature("TERRAINUSAGE",rec("TERRAINUSAGE_SID")).Name %></td>
        <tr>
        <tr>
            <td valign="top" nowrap class="cardPreview"><%= TR("Localization") %></td>
            <td valign="top" class="cardPreviewContent"><%= HTMLEncode(Elipsis(rec("RELATIVE_LOCALIZATION"),cCardEllipsis)) %></td>
            <td valign="top" nowrap class="cardPreview"><%= TR("Area") %></td>
            <td valign="top" class="cardPreviewContent"><%= FormatDouble(rec("AREA"),2) %> <%= TR("dka") %></td>
        <tr>
        <% If bLongView Then %>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Geomorhology") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("GEOFORM",rec("GEOFORM_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Orography") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("OROGRAPHY",rec("OROGRAPHY_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Hydrography") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("HYDROGRAPHY",rec("HYDROGRAPHY_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Soil") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("SOIL_TYPE",rec("SOIL_TYPE_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Elevation") %></td>
                <td valign="top" class="cardPreviewContent">
                    <% If Not IsNull(rec("ELEVATION")) Then
                        Response.Write ConvertTo(vbLong,rec("ELEVATION"))
                        If Not IsNull(rec("ELEVATION2")) Then Response.Write " - " & ConvertTo(vbLong,rec("ELEVATION2"))
                    End If %> 
                 </td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Exposition") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("EXPOSITION",rec("EXPOSITION_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Accessibility") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("ACCESSIBILITY",rec("ACCESSIBILITY_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Observability") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("OBSERVABILITY",rec("OBSERVABILITY_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Slope") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("SLOPE",rec("SLOPE_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Findings concentration") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("CONCENTRATION",rec("CONCENTRATION_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Findings grouping") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("GROUPING",rec("GROUPING_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Belongs to complex") %></td>
                <td valign="top" class="cardPreviewContent"><%= HTMLEncode(Elipsis(rec("BELONG_COMPLEX"),cCardEllipsis)) %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Belongs to system") %></td>
                <td valign="top" class="cardPreviewContent"><%= HTMLEncode(rec("BELONG_SYSTEM")) %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Belongs to culture") %></td>
                <td valign="top" class="cardPreviewContent"><%= HTMLEncode(Elipsis(rec("BELONG_CULTURE"),cCardEllipsis)) %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Official status") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("PROTECTION",rec("PROTECTION_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Importance") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("IMPORTANCE",rec("IMPORTANCE_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Guard") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("GUARD",rec("GUARD_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Environment") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("ENVIRONMENT",rec("ENVIRONMENT_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Preservation") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("PRESERVATION",rec("PRESERVATION_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Socialization") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("SOCIALIZATION",rec("SOCIALIZATION_SID")).Name %></td>
            <tr>
            <tr>
                <td valign="top" nowrap class="cardPreview"><%= TR("Usage regime") %></td>
                <td valign="top" class="cardPreviewContent"><%= Nomenclature("USAGEREGIME",rec("USAGEREGIME_SID")).Name %></td>
                <td valign="top" nowrap class="cardPreview"><%= TR("Status") %></td>
                <td valign="top" class="cardPreviewContent">&nbsp;(not impl.)</td>
            <tr>
            <% If Not IsNull(rec("MAP_IMAGE_SID")) Or Not IsNull(rec("PLOT_IMAGE_SID")) Then %>
                <tr>
                    <td valign="top" class="cardPreviewContent" colspan="4" style="width: 100%">
                        <% If Not IsNull(rec("MAP_IMAGE_SID")) Then %>
                            <img src="/image.asp?th=1&image=<%= rec("MAP_IMAGE_SID") %>" alt="<%= TR("Localization") %>" />
                        <% End If %>
                        <% If Not IsNull(rec("PLOT_IMAGE_SID")) Then %>
                            <img src="/image.asp?th=1&image=<%= rec("PLOT_IMAGE_SID") %>" alt="<%= TR("Plot") %>" />
                        <% End If %>
                    </td>
                <tr>
            <% End If %>
        <% End If %>
    </table>
    <%
End Function

%>