<!-- #include file="master-common.asp" -->
<!-- #include file="../usercontrols/uc-errormessages.asp" -->
<!-- #include file="../usercontrols/uc-verticaltabmenu.asp" -->
<%
MasterCancelProcessing = False

If PageRequiresAdmin Then
    If Not IsAdmin Then MasterCancelProcessing = True
End If

PageStyleSheet = VirtPath("/styles.css")

' MASTER CONTROLS
Set uLogin = New UCLogin
uLogin.CssClass = "dropDownSelector"
Set uGlobalErrorMessages = Create_UCErrorMessages(Empty)
Set uGlobalErrorMessages.Database = Database

ClientScripts.StopPropagation uLogin, "click"

Set cMasterBtnMenu = Create_UCButtonMenu(Empty)
cMasterBtnMenu.CssClass = "dropDownSelector"
cMasterBtnMenu.Style = "width:200px;"
cMasterBtnMenu.Transition = "Appear"
cMasterBtnMenu.ButtonContent = "<a href="""">" & IfThenElse(IsLoggedOn,TR("Logged on"),TR("Anonymous")) & "</a>"
' Set cMasterBtnMenu.DropControl = Create_UCLinkPanel(Empty)
Set cMasterBtnMenu.DropControl = uLogin
cMasterBtnMenu.DropControl.CssClass = "dropDownSelector"

Set cardMenu = New UCVerticalTabMenu
cardMenu.SkinId = "Entry"

Set btnOk = Create_CButton(Empty)
btnOk.SkinId = "Green"
btnOk.Caption = TR("Save")
Set btnClose = Create_CButton(Empty)
btnClose.SkinId = "Orange"
btnClose.Caption = TR("Close")
Set btnComplete = Create_CButton(Empty)
btnComplete.SkinId = "Blue"
btnComplete.Caption = TR("Complete")

ApplySkin

If CurrentCardId = 0 Then
    MasterCancelProcessing = True
    ASPRedirect = VirtPath("/")
End If

Sub RenderMaster
Begin_Page Empty ' This routine takes care for the whole head of the page - meta, keywords, link, title and so on.
' TO DO: Add the design below and place the standard elements where you want them
%>
      <% Begin_PostBackForm("") %>
      <center>
      <table border="0" width="100%" cellspacing="0" cellpadding="0" class="pageFrame">
      <tr>
        <td width="100%" class="pageTitle"><%= PageTitle %></td>
      </tr>
      <tr>
        <td width="100%" width="100%">
          <table border="0" width="100%" cellspacing="0" cellpadding="0" class="topmenu">
            <tr>
              <td nowrap style="width:100%;">
                <ul class="topmenu">
                    <li class="icon"><a href="<%= VirtPath("/") %>"><img src="<%= VirtPath("/img/home_grey.png") %>" border="0" alt="" /></a></li>
                    <li><a href="<%= VirtPath("/") %>"><%= TR("Home") %></a></li>
                </ul>
                <!-- #include file="master-adminmenu-top.asp" -->
              </td>
              <td align="right"><% cMasterBtnMenu.Render %></td>
            </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td width="100%" height="100%" valign="top" class="workArea">
          <table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%" >
            <tr>
              <td width="200" valign="top" style="vertical-align: top;" class="entryLeftPanel">
                <% cardMenu.Render %>
                
                    <table class="orangeBox">
                        <tr>
                            <td class="orangeBoxTL"><%= QuickHTMLImage("#pixel",8,1) %></td>
                            <td class="orangeBoxT"><%= QuickHTMLImage("#pixel",8,8) %></td>
                            <td class="orangeBoxTR"><%= QuickHTMLImage("#pixel",8,1) %></td>
                        </tr>
                        <tr>
                            <td class="orangeBoxL"><%= QuickHTMLImage("#pixel",8,1) %></td>
                            <td class="orangeBoxM">
                                &nbsp;<% btnOk.Render %><br/>
                                &nbsp;<% btnClose.Render %><hr/>
                                &nbsp;<% btnComplete.Render %>
                            </td>
                            <td class="orangeBoxR"><%= QuickHTMLImage("#pixel",8,1) %></td>
                        </tr>
                        <tr>
                            <td class="orangeBoxBL"><%= QuickHTMLImage("#pixel",8,1) %></td>
                            <td class="orangeBoxB"><%= QuickHTMLImage("#pixel",8,8) %></td>
                            <td class="orangeBoxBR"><%= QuickHTMLImage("#pixel",8,1) %></td>
                        </tr>
                    </table>
                
                <!-- #include file="master-menu-top.asp" -->
              </td>
              <td valign="top" style="vertical-align: top;">
                <% uGlobalErrorMessages.Render %>
                <% RenderPage %>
              </td>
            </tr>
          </table>
        </td>
    </tr>
    <tr>
        <td width="100%">
          <table width="100%" cellspacing="0" cellpadding="0" class="masterfooter">
            <tr>
              <td align="middle">
                Copyright &copy; [Archeological authority]
              </td>
            </tr>
          </table>    
        </td>
    </tr>
    </table>
</center>
    <% End_PostBackForm %>
    <% hint.Render %>
<%
' TO DO: Uncomment temporarily if you need tracing and summary information to be displayed at the bottom of the page.
' DumpRequest
End_Page
End Sub

uLogin.MasterProcessPage

StandardMasterPageProcessing VirtPath("/")

%>
