<%
    Class UCPropSheet ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
            Public Props ' Prop 
        
        ' CONTROLS
            Private PropTypes
            Private btnApply, btnEdit           
            
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        Sub Class_Initialize
            Set Props = CreateDictionary
            Set PropTypes = CreateDictionary
            
            
        End Sub
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            Dim o
            Set o = New UCPropSheetPropType
            o.Init "Text", Create_CText(Empty), "ReaderCText", "WriterCText", "InitCText", Empty
            PropTypes.Add o.Name, o
            o.Control.Style = "width:400px;"
            
            Set o = New UCPropSheetPropType
            o.Init "Integer", Create_CText(Empty), "ReaderCInt", "WriterCInt", "InitCInt", Empty
            PropTypes.Add o.Name, o
            o.Control.Style = "width:400px;"
            
            Set o = New UCPropSheetPropType
            o.Init "Double", Create_CText(Empty), "ReaderCDbl", "WriterCDbl", "InitCDbl", "FormatCDbl"
            PropTypes.Add o.Name, o
            o.Control.Style = "width:400px;"
            
            Set o = New UCPropSheetPropType
            o.Init "Date", Create_CDateBox(Empty), "ReaderCDate", "WriterCDate", "InitCDate", "FormatCDate"
            PropTypes.Add o.Name, o
            o.Control.Style = "width:400px;"
            
            Set o = New UCPropSheetPropType
            o.Init "List", Create_CList(Empty), "ReaderCList", "WriterCList", "InitCList", "FormatCList"
            PropTypes.Add o.Name, o
            o.Control.Style = "width:400px;"
            
            Set o = New UCPropSheetPropType
            o.Init "Tree", Create_UCTreeNomReadOnly(Empty), "ReaderUCTreeNom", "WriterUCTreeNom", "InitUCTreeNom", "FormatUCTreeNom"
            PropTypes.Add o.Name, o
            
            Set o = New UCPropSheetPropType
            o.Init "Person", Create_UCPersons(Empty), "ReaderUCPerson", "WriterUCPerson", "InitUCPerson", "FormatUCPerson"
            PropTypes.Add o.Name, o
            
            Set o = New UCPropSheetPropType
            o.Init "Location", Create_UCLocationReadOnly(Empty), "ReaderUCLocation", "WriterUCLocation", "InitUCLocation", "FormatUCLocation"
            PropTypes.Add o.Name, o
            o.Control.AsyncPostBack(o.Control) = True
            o.Control.Width = 400
            o.Control.Height = 300
            
            
            Set btnApply = Create_CImageButton(Empty)
            btnApply.SkinId = "PropSheetApply"
            btnApply.AsyncPostBack(Me) = True
            Set btnEdit = Create_CImageButton(Empty)
            btnEdit.SkinId = "PropSheetEdit"
            btnEdit.AsyncPostBack(Me) = True
            
            ' INIT CONTAINED USER CONTROLS
            '   TO DO: Initialize any user controls contained in this control e.g.
            '   Set myUserControl = New UCMyUserControl
            '   myUserControl.SomeProperty = Something
            
            ' INIT CONTAINED WEB CONTROLS
            '   TO DO: Create/initialize all the contained controls you use here e.g.
                ' Set txtBox = Create_CText(Empty)
                ' Set btnOk = Create_CButton(Empty)
                    ' Async post back examples
                    ' btnOk.AsyncPostBack(Me) = True ' Enable asynchronous partial post back to be initiated by this button
                    ' Set txtBox.AsyncPostBack(Me) = btnOk ' Enable async post back on text change on behalf of btnOk
                ' example validator
                ' Set vldBox = Create_CValidatorFor(Empty, txtBox, "ValidateRequired,ValidateLength")
                ' vldBox.Required = True
                ' vldBox.MaxLength = 128
                ' vldBox.Group = Me.Name ' It is important to assign an unique group name to the validators in the user control
                '                        In order to avoid mixing them with the validators outside. The easiest way is to assign the 
                '                        name of the user control as group name. Then validate them using Validate(Me.Name)
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
            CssClass = "propsheet"
        End Sub
        
        Function Load(binder,r)
            Dim I
            For I = 1 To Props.Count
                Values.Item(Props(I).Id) = binder.Value(r,Props(I).Id)
            Next
            Load = True
        End Function
        Function Save(binder,r)
            Dim I
            For I = 1 To Props.Count
                Values.Missing = Null
                binder.Value(r,Props(I).Id) = Values.Item(Props(I).Id)
                ' Response.Write Props(I).Id & "=" & binder.Value(r,Props(I).Id) & "<br/>"
            Next
            Save = True
        End Function
        
        Public Function AddProperty(pid, ptype, pname)
            Dim o
            Set o = New UCPropSheetPropDesc
            o.Init pid, pname, PropTypes(ptype)
            Props.Add pid, o
            Set AddProperty = o
        End Function
        Public Function RemoveProperty(pid)
            Props.Remove pid
        End Function
        
        Function ApplyCurrent
            Dim o
            ApplyCurrent = False
            If Len(Active) > 0 Then
                Set o = Props(Active)
                If o.ValidateProperty Then
                    Values.Item(Active) = o.PropType.Value
                    ApplyCurrent = True
                End If
            Else
                ApplyCurrent = True
            End If
        End Function
        Function ChangeCurrent(n)
            Dim nprop
            nprop = ConvertTo(vbLong, n)
            If nprop > 0 Then
                Active = Props(nprop).Id
                InitCurrent
                Props(nprop).PropType.Value = Values.Item(Active)
            Else
                Active = ""
            End If
        End Function
        Sub InitCurrent
            Dim o
            If Len(Active) > 0 Then
                Set o = Props(Active)
                o.PropType.InitProp(o)
            End If
        End Sub
        Public Function Close
            Close = ApplyCurrent
            ChangeCurrent 0
        End Function
        
        Sub ProcessPage
            InitCurrent
            
            If IsPostBack Then
                If btnEdit.Clicked Then
                    If ApplyCurrent Then
                        ChangeCurrent btnEdit.Value                        
                    End If
                ElseIf btnApply.Clicked Then
                    If ApplyCurrent Then
                        Active = ""
                    End If
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        ' The active property setting - zero lenth non-active
        Public Property Get Active
            Active = ConvertTo(vbString,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbString,v)
        End Property
        Public Property Get Values
            Set Values = PostVariables.CtlPostCollection(Me,"P")
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            ' TO DO: If you want to attach validators to this user control this property will be used by all the standard validator procedures
            '   return whatever is appropriate for validation. For example if this control enables the user to select something and you want to attach
            '   a "required validator" you need to return Empty when nothing is selected and something else (a database Id of the item for example) otherwise.
            '   While the Value is not declared as default (to leave the option usable for other purposes) it is intended for library usage. It may be needed
            '   for future functionality enhancements - be careful to implement it as described.
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCPropSheet" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            Dim I
            %>
            <table class="propsheet">
                <%
                For I = 1 To Props.Count
                    RenderCell Props(I), I
                Next
                %>
            </table>
            <%
        End Sub
        Public Sub RenderCell(pdesc, nprop)
            If Active = pdesc.Id Then
            %>
            <tr>
                <th nowrap class="labelActive" onclick="<%= btnApply.GetAsyncPostBack(Me,0) %>" style="cursor: pointer;"><%= pdesc.Name %></th>
                <td class="fieldActive"><%
                    pdesc.PropType.Control.Render
                    pdesc.RenderValidator
                %></td>
                <td class="button"><% btnApply.Render %></td>
            </tr>
            <%
            Else
            %>
            <tr onclick="<%= btnEdit.GetAsyncPostBack(Me,nprop) %>" style="cursor: pointer;">
                <th nowrap class="label"><%= pdesc.Name %></th>
                <td class="field"><%= pdesc.PropType.Display(pdesc, Values.Item(pdesc.Id)) %></td>
                <td class="button"><% btnEdit.RenderValue(nprop) %></td>
            </tr>
            <%
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCPropSheet(ctlName) 
        Set ctl = New UCPropSheet ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCPropSheet = ctl ' TO DO: Change the control name
    End Function
    
    Class UCPropSheetPropDesc
        Public Id, Name, Description, PropType, NotNull
        Public Table, Params, PropValidator ' Typical params
        Sub Class_Initialize
            Id = Null
            Set Params = CreateDictionary
        End Sub
        Sub Init(pid, pname, otype)
            Id = pid
            Name = pname
            Set PropType = oType
        End Sub
        Function ValidateProperty
            ValidateProperty = True
            If IsObject(PropValidator) Then
                ValidateProperty = PropValidator.PerformValidate 
            End If
        End Function
        Sub RenderValidator
            If IsObject(PropValidator) Then
                PropValidator.Render
            End If
        End Sub
    End Class
    
    Class UCPropSheetPropType
        Public Name, Control
        Public Reader, Writer ' Procedures x = Reader(PropType obj), Writer(PropType obj, Variant val)
        Public Initializer, Formatter
        Sub Init(n,c,r,w,i,f)
            Name = n
            Set Control = c
            Set Reader = GetRef("UCPropSheet_" & r)
            Set Writer = GetRef("UCPropSheet_" & w)
            If Len(i) > 0 Then Set Initializer = GetRef("UCPropSheet_" & i)
            If Len(f) > 0 Then Set Formatter = GetRef("UCPropSheet_" & f)
        End Sub
        Public Property Get Value
            Value = Reader(Me)
        End Property
        Public Property Let Value(v)
            Writer Me,v
        End Property
        Public Sub InitProp(desc) ' PropDesc desc
            If IsObject(desc.PropValidator) Then
                Set desc.PropValidator.ControlToValidate = Control
            End If
            If IsObject(Initializer) Then
                
                Initializer desc
            End If
        End Sub
        Public Function Display(pdesc, v)
            If IsObject(Formatter) Then
                Display = Formatter(pdesc, Me, v)
            Else
                Display = v
            End If
        End Function
    End Class
    
    Function UCPropSheet_ReaderCText(o)
        UCPropSheet_ReaderCText = NullConvertTo(vbString,o.Control.Value)
    End Function
    Function UCPropSheet_WriterCText(o,v)
        o.Control.Value = ConvertTo(vbString, v)
    End Function
    Function UCPropSheet_InitCText(p)
        ' Nothing
    End Function
    
    Function UCPropSheet_ReaderCInt(o)
        UCPropSheet_ReaderCInt = NullConvertTo(vbLong,o.Control.Value)
    End Function
    Function UCPropSheet_WriterCInt(o,v)
        o.Control.Value = ConvertTo(vbLong, v)
    End Function
    Function UCPropSheet_InitCInt(p)
        ' Nothing
    End Function
    
    Function UCPropSheet_ReaderCDbl(o)
        UCPropSheet_ReaderCDbl = NullConvertTo(vbDouble,o.Control.Value)
    End Function
    Function UCPropSheet_WriterCDbl(o,v)
        o.Control.Value = StringUtilities.Sprintf("%8f",ConvertTo(vbDouble, v))
    End Function
    Function UCPropSheet_InitCDbl(p)
        ' Nothing
    End Function
    Function UCPropSheet_FormatCDbl(desc,t,v)
        UCPropSheet_FormatCDbl = StringUtilities.Sprintf("%8f",ConvertTo(vbDouble, v))
    End Function
    
    Function UCPropSheet_ReaderCDate(o)
        UCPropSheet_ReaderCDate = NullConvertTo(vbDouble,o.Control.DateValue)
    End Function
    Function UCPropSheet_WriterCDate(o,v)
        o.Control.DateValue = ConvertTo(vbDate,v)
    End Function
    Function UCPropSheet_InitCDate(p)
        p.PropType.Control.Format = PageUIDateFormat
        p.PropType.Control.Attributes.Item("title") = PageUIDateFormat
    End Function
    Function UCPropSheet_FormatCDate(desc,t,v)
        UCPropSheet_FormatCDate = FormatDateString(v,PageUIDateFormat)
    End Function
    
    Function UCPropSheet_ReaderCList(o)
        UCPropSheet_ReaderCList = NullConvertTo(vbLong,o.Control.SelectedValue)
    End Function
    Function UCPropSheet_WriterCList(o,v)
        o.Control.SelectedValue = ConvertTo(vbLong, v)
    End Function
    Function UCPropSheet_InitCList(p)
        Dim o, I
        Set o = p.PropType.Control
        o.Items.Clear
        o.AddItem "", ""
        o.AddSQLiteItems Database.DB.VExecute("SELECT SID, NAME, CODE FROM [" & p.Table & "] WHERE " & SQLReadRights & " AND LANGUAGE=$LANGUAGE ORDER BY NAME",1,0,PageUILanguage), "SID", "NAME"
    End Function
    Function UCPropSheet_FormatCList(desc,t,v)
        Dim r
        Set r = Database.DB.VExecute("SELECT * FROM [" & desc.Table & "] WHERE SID=$SID AND LANGUAGE=$LANGUAGE",1,0,NullConvertTo(vbLong,v),PageUILanguage)
        If r.Count > 0 Then
            UCPropSheet_FormatCList = ConvertTo(vbString,r(1)("NAME"))
        End If
    End Function
    
    Function UCPropSheet_ReaderUCTreeNom(o)
        UCPropSheet_ReaderUCTreeNom = NullConvertTo(vbLong,o.Control.Value)
    End Function
    Function UCPropSheet_WriterUCTreeNom(o,v)
        o.Control.Value = ConvertTo(vbLong, v)
    End Function
    Function UCPropSheet_InitUCTreeNom(p)
        Dim o, I
        Set o = p.PropType.Control
        o.AsyncPostBack(o) = True
        o.Nomenclature = p.Table
        o.Width = 400
        o.Height = 200
    End Function
    Function UCPropSheet_FormatUCTreeNom(desc,t,v)
        Dim r
        Set r = Database.DB.VExecute("SELECT * FROM [" & desc.Table & "] WHERE SID=$SID AND LANGUAGE=$LANGUAGE",1,0,NullConvertTo(vbLong,v),PageUILanguage)
        If r.Count > 0 Then
            UCPropSheet_FormatUCTreeNom = ConvertTo(vbString,r(1)("NAME"))
        End If
    End Function
    
    Function UCPropSheet_ReaderUCPerson(o)
        UCPropSheet_ReaderUCPerson = NullConvertTo(vbLong,o.Control.Value)
    End Function
    Function UCPropSheet_WriterUCPerson(o,v)
        o.Control.Value = ConvertTo(vbLong, v)
    End Function
    Function UCPropSheet_InitUCPerson(p)
        Dim o, I
        Set o = p.PropType.Control
        ' ???
    End Function
    Function UCPropSheet_FormatUCPerson(desc,t,v)
        Dim p
        Set p = GetPerson(NullConvertTo(vbLong,v),PageUILanguage)
        UCPropSheet_FormatUCPerson = p.Name
    End Function

    Function UCPropSheet_ReaderUCLocation(o)
        UCPropSheet_ReaderUCLocation = NullConvertTo(vbLong,o.Control.Value)
    End Function
    Function UCPropSheet_WriterUCLocation(o,v)
        o.Control.Value = ConvertTo(vbLong, v)
    End Function
    Function UCPropSheet_InitUCLocation(p)
        Dim o, I
        Set o = p.PropType.Control
        o.AsyncPostBack(o) = True
        o.Width = 400
        o.Height = 200
    End Function
    Function UCPropSheet_FormatUCLocation(desc,t,v)
        UCPropSheet_FormatUCLocation = GetLocation(ConvertTo(vbLong,v)).FullName
    End Function
%>