<%

    Class UCFileAttachments ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        Public CssClassImagesHorizontal, CssClassImagesVertical
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        Public Limit ' Limits the number of attachments
        Public ShowLimit
        Public EditMode ' If True the control is in edit mode - should be controlled by the containing control
        Public View
        Public ParentId
        
        ' CONTROLS
        Private cFile, btnEdit, btnRemove, btnTop, btnBottom, btnAdd
        Private pager
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set cFile = Create_UCFileDlg(Empty)
            cFile.ShowSelected = True
            
            
            Set btnEdit = Create_CButton(Me.Name & "_IE")
            btnEdit.Caption = TR("Change file")
            btnEdit.AsyncPostBack(Me) = True
            btnEdit.SkinId = "Yellow"
            Set btnRemove = Create_CButton(Me.Name & "_IR")
            btnRemove.Caption = TR("Remove attachment")
            btnRemove.AsyncPostBack(Me) = True
            btnRemove.SkinId = "Orange"
            Set btnTop = Create_CButton(Me.Name & "_IT")
            btnTop.Caption = TR("To top")
            btnTop.AsyncPostBack(Me) = True
            btnTop.SkinId = "Blue"
            Set btnBottom = Create_CButton(Me.Name & "_IB")
            btnBottom.Caption = TR("To bottom")
            btnBottom.AsyncPostBack(Me) = True
            btnBottom.SkinId = "Blue"
            Set btnAdd = Create_CButton(Me.Name & "_IA")
            btnAdd.Caption = TR("Add file attachment")
            btnAdd.AsyncPostBack(Me) = True
            
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            Limit = cMaxFileAttachments
            ShowLimit = 5
            View = "Horizontal"
            
        End Sub
        
        ' SESSION Preferences
        Public Sub InitSessionPreferences(vars)
        End Sub
        Public Sub SavePrefs
        End Sub
        Public Sub LoadPrefs
        End Sub
        
        Public Function Load
            Dim sid, r, I
            sid = ObjectId
            Files.Clear
            cFile.Mode = UCFileDlg_Slim
            If sid <> 0 Then
                Set r = Database.DB.VExecute("SELECT I.SID FROM FILE I, RELATION R WHERE I.SID=R.TARGET_SID AND R.OBJECT_SID=$OBJECT_SID AND " & _
                                             " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I") & " ORDER BY R.ORDER_TAG", _
                                             1, 0, sid, PageUILanguage)
                For I = 1 To r.Count
                    Files.Add "", ConvertTo(vbLong, r(I)("SID"))
                Next
                Load = True
            Else
                Load = True
            End If
        End Function
        Public Function UnLoad
            Files.Clear
        End Function
        Public Function Save
            Dim sid, I
            Save = False
            sid = ObjectId
            If Database.BeginTransaction Then
                Database.DB.VExecute "DELETE FROM RELATION WHERE OBJECT_SID=$OBJECT_SID AND OBJECT_TYPE='FILE'", 1, 0, sid
                For I = 1 To Files.Count
                    If ConvertTo(vbLong,Files.Item(I)) <> 0 Then
                        Database.DB.VExecute "INSERT INTO RELATION (OBJECT_SID, TARGET_SID, ORDER_TAG, OBJECT_TYPE) VALUES " & _
                                             "($OBJECT_SID, $TARGET_SID, $ORDER_TAG, 'FILE')", 1, 0, sid, NullConvertTo(vbLong,Files.Item(I)),I
                    End If
                Next
                If Database.CompleteTransaction Then
                    Save = True
                End If
            End If
        End Function
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If bSuccess Then
                
            End If
        End Function
        
        Private Function RemoveItem(itm)
            RemoveItem = 0
            imgId = ConvertTo(vbLong, itm)
            For I = 1 To Files.Count
                If Files.Item(I) = imgId Then
                    Files.Remove I
                    RemoveItem = imgId
                    Exit For
                End If
            Next
        End Function
        Sub ProcessPage
            Dim I, imgId
            If IsPostBack Then
                If btnAdd.Clicked Then
                    cFile.Load 0
                    Id = 0
                ElseIf btnEdit.Clicked Then
                    Id = Files.Item(ConvertTo(vbLong, btnEdit.Value))
                    If Not cFile.Load(Id) Then Id = 0
                ElseIf btnRemove.Clicked Then
                    Files.Remove ConvertTo(vbLong, btnRemove.Value)
                ElseIf btnTop.Clicked Then
                    imgId = Files.Item(ConvertTo(vbLong, btnTop.Value))
                    Files.Remove ConvertTo(vbLong, btnTop.Value)
                    If imgId <> 0 Then Files.Insert 1, imgId
                ElseIf btnBottom.Clicked Then
                    imgId = Files.Item(ConvertTo(vbLong, btnBottom.Value))
                    Files.Remove ConvertTo(vbLong, btnBottom.Value)
                    If imgId <> 0 Then Files.Add "", imgId
                ElseIf cFile.Closed Then
                    OvertakePartialRender Me
                    If cFile.Id <> 0 Then
                        ImgId = cFile.Id
                        If Id <> 0 Then
                            For I = 1 To Files.Count
                                If Files.Item(I) = Id Then
                                    Files.Item(I) = ImgId
                                    ImgId = 0
                                    Exit For
                                End If
                            Next
                            If ImgId <> 0 Then Files.Add "", ImgId
                            ImgId = 0
                        Else
                            If ImgId <> 0 Then Files.Add "", cFile.Id
                        End If
                    Else
                        RemoveItem Id
                    End If
                    Id = 0
                End If
            End If
        
        End Sub
        
        ' POST VARIABLES
        Public Property Get Files
            Set Files = PostVariables.CtlPostCollection(Me,"IM")
        End Property
        ' EditId
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get ObjectId
            ObjectId = ParentId
        End Property
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCFileAttachments" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            If EditMode Then
                RenderEdit
            Else
                If UCase(Left(View,1)) = "V" Then
                    RenderVertical
                Else
                    RenderHorizontal
                End If
            End If
        End Sub
        Public Sub RenderEdit
            Dim I, rFiles, rec
            If cFile.Mode <> 0 Then
                cFile.Render
            Else
                Set r = Database.DB.VExecute("SELECT I.* FROM FILE I WHERE " & _
                                                 " I.SID IN (" & CreateSQLInList(Files) & ") AND " & _
                                                 " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I"), _
                                                 1, 0, PageUILanguage)
                Set rFiles = CreateCollection                                             
                For I = 1 To r.Count
                    rFiles.Add ConvertTo(vbString, r(I)("SID")), r(I)
                Next                                            
                pager.ItemCount = Files.Count 
                %>
                <table class="ImageListViewSelect" cellspacing="1">
                    <%
                    For I = pager.Page * PageSize + 1 To Files.Count
                    %>
                    <tr>
                        <% 
                        Set rec = rFiles(ConvertTo(vbString,Files.Item(I)))
                        bPutBr = False
                        %>
                        <td class="<%= elementCss & "text" %>">
                            <%= DisplayFileIcon(rec("SID"),True) %><br/>
                            <%  
                                If CurrentUser.CanWrite(rec) Then
                                    btnEdit.RenderValue(I) 
                                End If
                                btnRemove.RenderValue(I) 
                            %>&nbsp;
                            <% btnTop.RenderValue(I) : btnBottom.RenderValue(I) %><br/>
                            <% 
                            Response.Write "<strong>" & HTMLEncode(rec("CAPTION")) & "</strong>"
                            Response.Write "&nbsp;(" & FileSizeString(rec("SIZE")) & ")<br/>"
                            %>
                        </td>
                    </tr>
                    <%
                    Next
                    %>
                    <tr>
                        <td colspan="2" class="pager">
                            <% pager.Render %>
                        </td>
                    </tr>
                </table>
                <%
                btnAdd.Render
            End If
        End Sub
        Private Function GetFilesList
            Set rFiles = Database.DB.VExecute("SELECT I.* FROM FILE I, RELATION R WHERE I.SID=R.TARGET_SID AND R.OBJECT_SID=$OBJECT_SID AND " & _
                                             " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I") & " ORDER BY R.ORDER_TAG LIMIT " & ShowLimit, _
                                             1, 0, ObjectId, PageUILanguage)
            Set GetFilesList = rFiles
        End Function
        Public Sub RenderHorizontal
            Dim I, rFiles
            Set rFiles = GetFilesList
            If rFiles.Count > 0 Then
            %>
            <table class="<%= CssClassImagesHorizontal %>">
                <tr>
                    <td class="list">
                    <% 
                        For I = 1 To rFiles.Count
                            Response.Write DisplayFileIconFromRecord(rFiles(I),True) & " "
                        Next
                    %>
                    </td>
                </tr>
            </table>
            <%
            End If
        End Sub
        Public Sub RenderImagesVertical
            Dim I,imgSrc, rImgs
            Set rImgs = GetImagesList
            If rImgs.Count > 0 Then
            %>
            <table class="<%= CssClassImagesVertical %>">
                <tr>
                    <td class="space">&nbsp;</td>
                    <% 
                        For I = 1 To rImgs.Count
                            imgSrc = VirtPath("/image.asp") & "?image=" & rImgs(I)("SID")
                            %>
                            <td class="thumbnail">
                                <a href="<%= imgSrc %>" target="_blank"><img src="<%= imgSrc & "&th=4" %>" border="0" alt="" width="<%= ThumbNailSizeIconSmall %>"/></a>
                            </td>
                            <%
                        Next
                    %>
                </tr>
            </table>
            <%
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCFileAttachments(ctlName) 
        Set ctl = New UCFileAttachments ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCFileAttachments = ctl ' TO DO: Change the control name
    End Function

%>