<%

    Class UCImageAttachments ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        Public CssClassImagesHorizontal, CssClassImagesVertical
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        Public Limit ' Limits the number of attachments
        Public ShowLimit
        Public EditMode ' If True the control is in edit mode - should be controlled by the containing control
        Public View
        Public ParentId
        
        ' CONTROLS
        Private cImage, btnEdit, btnRemove, btnTop, btnBottom, btnAdd
        Private pager
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set cImage = Create_UCImageDlg(Empty)
            cImage.ShowSelected = True
            
            
            Set btnEdit = Create_CButton(Me.Name & "_IE")
            btnEdit.Caption = TR("Edit image")
            btnEdit.AsyncPostBack(Me) = True
            btnEdit.SkinId = "Yellow"
            Set btnRemove = Create_CButton(Me.Name & "_IR")
            btnRemove.Caption = TR("Remove attachment")
            btnRemove.AsyncPostBack(Me) = True
            btnRemove.SkinId = "Orange"
            Set btnTop = Create_CButton(Me.Name & "_IT")
            btnTop.Caption = TR("To top")
            btnTop.AsyncPostBack(Me) = True
            btnTop.SkinId = "Blue"
            Set btnBottom = Create_CButton(Me.Name & "_IB")
            btnBottom.Caption = TR("To bottom")
            btnBottom.AsyncPostBack(Me) = True
            btnBottom.SkinId = "Blue"
            Set btnAdd = Create_CButton(Me.Name & "_IA")
            btnAdd.Caption = TR("Add image attachment")
            btnAdd.AsyncPostBack(Me) = True
            
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            Limit = cMaxImageAttachments
            ShowLimit = 5
            View = "Horizontal"
            
        End Sub
        
        ' SESSION Preferences
        ' TO DO: If you do not need session preferences you can remove the 3 members below
        '   Call SavePrefs in the Render phase - as late as possible
        '   Call LoadPrefs in ProcessPage or from outside when the control shows for the first time. Note that choosing the right conditions may be tricky
        '       depending on the way the application is designed. Check the documentation for a discussion on how to find the right conditions.
        Public Sub InitSessionPreferences(vars)
            ' TO DO: Set initial values for the session preferences used by this control
            '   example:
            '   vars("myparam") = "hello"
        End Sub
        Public Sub SavePrefs
            ' TO DO: save the values of the session preferences
            '   example:
            '   SessionPreferences.SetCtlVar Me, "myparam", txtTextBox1.Value
            '   ' A session preference may correspond to a value of a contained control, internal variable or a property
            '   ' In this routine you must fetch it and pass it to the SessionPreferences global singleton class for safekeeping
        End Sub
        Public Sub LoadPrefs
            ' TO DO: Recover the values of the session preferences 
            '   example:
            '   txtTextBox1.Value = ConvertTo(vbString,SessionPreferences.GetCtlVar(Me, "myparam"))
            '   ' When restoring the session preferences you must assign them to their roles inside the control.
            '   ' They may correspond to a value of a contained control (like the example line above), a variable, a property or they
            '   ' can even be only a base over which more than one values are calculated - this is up to you.
        End Sub
        
        Public Function Load
            Dim sid, r, I
            sid = ObjectId
            Images.Clear
            cImage.Mode = UCImageDlg_Slim
            If sid <> 0 Then
                Set r = Database.DB.VExecute("SELECT I.SID FROM IMAGE I, RELATION R WHERE I.SID=R.TARGET_SID AND R.OBJECT_SID=$OBJECT_SID AND " & _
                                             " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I") & " ORDER BY R.ORDER_TAG", _
                                             1, 0, sid, PageUILanguage)
                For I = 1 To r.Count
                    Images.Add "", ConvertTo(vbLong, r(I)("SID"))
                Next
                Load = True
            Else
                Load = True
            End If
        End Function
        Public Function UnLoad
            Images.Clear
            
        End Function
        Public Function Save
            Dim sid, I
            Save = False
            sid = ObjectId
            If Database.BeginTransaction Then
                Database.DB.VExecute "DELETE FROM RELATION WHERE OBJECT_SID=$OBJECT_SID AND OBJECT_TYPE='IMAGE'", 1, 0, sid
                For I = 1 To Images.Count
                    If ConvertTo(vbLong,Images.Item(I)) <> 0 Then
                        Database.DB.VExecute "INSERT INTO RELATION (OBJECT_SID, TARGET_SID, ORDER_TAG, OBJECT_TYPE) VALUES " & _
                                             "($OBJECT_SID, $TARGET_SID, $ORDER_TAG, 'IMAGE')", 1, 0, sid, NullConvertTo(vbLong,Images.Item(I)),I
                    End If
                Next
                If Database.CompleteTransaction Then
                    Save = True
                End If
            End If
        End Function
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If bSuccess Then
                
            End If
        End Function
        
        Private Function RemoveItem(itm)
            RemoveItem = 0
            imgId = ConvertTo(vbLong, itm)
            For I = 1 To Images.Count
                If Images.Item(I) = imgId Then
                    Images.Remove I
                    RemoveItem = imgId
                    Exit For
                End If
            Next
        End Function
        Sub ProcessPage
            Dim I, imgId
            If IsPostBack Then
                If btnAdd.Clicked Then
                    cImage.Load 0
                    Id = 0
                ElseIf btnEdit.Clicked Then
                    Id = Images.Item(ConvertTo(vbLong, btnEdit.Value))
                    If Not cImage.Load(Id) Then Id = 0
                ElseIf btnRemove.Clicked Then
                    Images.Remove ConvertTo(vbLong, btnRemove.Value)
                ElseIf btnTop.Clicked Then
                    imgId = Images.Item(ConvertTo(vbLong, btnTop.Value))
                    Images.Remove ConvertTo(vbLong, btnTop.Value)
                    If imgId <> 0 Then Images.Insert 1, imgId
                ElseIf btnBottom.Clicked Then
                    imgId = Images.Item(ConvertTo(vbLong, btnBottom.Value))
                    Images.Remove ConvertTo(vbLong, btnBottom.Value)
                    If imgId <> 0 Then Images.Add "", imgId
                ElseIf cImage.Closed Then
                    OvertakePartialRender Me
                    If cImage.Id <> 0 Then
                        ImgId = cImage.Id
                        If Id <> 0 Then
                            For I = 1 To Images.Count
                                If Images.Item(I) = Id Then
                                    Images.Item(I) = ImgId
                                    ImgId = 0
                                    Exit For
                                End If
                            Next
                            If ImgId <> 0 Then Images.Add "", ImgId
                            ImgId = 0
                        Else
                            If ImgId <> 0 Then Images.Add "", cImage.Id
                        End If
                    Else
                        RemoveItem Id
                    End If
                    Id = 0
                End If
            End If
        
        End Sub
        
        ' POST VARIABLES
        Public Property Get Images
            Set Images = PostVariables.CtlPostCollection(Me,"IM")
        End Property
        ' EditId
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get ObjectId
            ObjectId = ParentId
        End Property
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            ' TO DO: If you want to attach validators to this user control this property will be used by all the standard validator procedures
            '   return whatever is appropriate for validation. For example if this control enables the user to select something and you want to attach
            '   a "required validator" you need to return Empty when nothing is selected and something else (a database Id of the item for example) otherwise.
            '   While the Value is not declared as default (to leave the option usable for other purposes) it is intended for library usage. It may be needed
            '   for future functionality enhancements - be careful to implement it as described.
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCImageAttachments" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            If EditMode Then
                RenderEdit
            Else
                If UCase(Left(View,1)) = "V" Then
                    RenderImagesVertical
                Else
                    RenderImagesHorizontal
                End If
            End If
        End Sub
        Public Sub RenderEdit
            Dim I, rImgs, rec
            If cImage.Mode <> 0 Then
                cImage.Render
            Else
                Set r = Database.DB.VExecute("SELECT I.* FROM IMAGE I WHERE " & _
                                                 " I.SID IN (" & CreateSQLInList(Images) & ") AND " & _
                                                 " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I"), _
                                                 1, 0, PageUILanguage)
                Set rImgs = CreateCollection                                             
                For I = 1 To r.Count
                    rImgs.Add ConvertTo(vbString, r(I)("SID")), r(I)
                Next                                            
                pager.ItemCount = Images.Count 
                %>
                <table class="ImageListViewSelect" cellspacing="1">
                    <%
                    For I = pager.Page * PageSize + 1 To Images.Count
                    %>
                    <tr>
                        <% 
                        Set rec = rImgs(ConvertTo(vbString,Images.Item(I)))
                        bPutBr = False
                        %>
                        <td class="<%= elementCss %>" style="<%= "width:" & ThumbNailSizeIconSmall & "px;height:" & ThumbNailSizeIconSmall & "px;" %>"><img src="<%= VirtPath("/image.asp") & "?image=" & rec("SID") & "&th=4" %>" border="0" alt="" width="<%= ThumbNailSizeIconSmall %>"/></td>
                        <td class="<%= elementCss & "text" %>">
                            <%  
                                If CurrentUser.CanWrite(rec) Then
                                    btnEdit.RenderValue(I) 
                                End If
                                btnRemove.RenderValue(I) 
                            %>&nbsp;
                            <% btnTop.RenderValue(I) : btnBottom.RenderValue(I) %><br/>
                            <% 
                            Response.Write "<strong>" & HTMLEncode(rec("CAPTION")) & "</strong>"
                            Response.Write "&nbsp;(" & ConvertTo(vbString,rec("WIDTH")) & " x " & ConvertTo(vbString,rec("HEIGHT")) & ")<br/>"
                            Response.Write "Insert <b>[image " & ConvertTo(vbLong,rec("SID")) & "]</b> in the text to embed this image."
                            %>
                        </td>
                    </tr>
                    <%
                    Next
                    %>
                    <tr>
                        <td colspan="2" class="pager">
                            <% pager.Render %>
                        </td>
                    </tr>
                </table>
                <%
                btnAdd.Render
            End If
        End Sub
        Private Function GetImagesList
            Set rImgs = Database.DB.VExecute("SELECT I.* FROM IMAGE I, RELATION R WHERE I.SID=R.TARGET_SID AND R.OBJECT_SID=$OBJECT_SID AND " & _
                                             " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I") & " ORDER BY R.ORDER_TAG LIMIT " & ShowLimit, _
                                             1, 0, ObjectId, PageUILanguage)
            Set GetImagesList = rImgs                                             
        End Function
        Public Sub RenderImagesHorizontal
            Dim I,imgSrc, rImgs
            Set rImgs = GetImagesList
            If rImgs.Count > 0 Then
            %>
            <table class="<%= CssClassImagesHorizontal %>">
                <tr>
                    <td class="space">&nbsp;</td>
                    <% 
                        For I = 1 To rImgs.Count
                            imgSrc = VirtPath("/image.asp") & "?image=" & rImgs(I)("SID")
                            %>
                            <td class="thumbnail">
                                <a href="<%= imgSrc %>" target="_blank"><img src="<%= imgSrc & "&th=3" %>" border="0" width="<%= ThumbNailSizeIconSmall %>" 
                                    alt="<%= HTMLEncode(rImgs(I)("CAPTION")) %>" /></a>
                            </td>
                            <%
                        Next
                    %>
                </tr>
            </table>
            <%
            End If
        End Sub
        Public Sub RenderImagesVertical
            Dim I,imgSrc, rImgs
            Set rImgs = GetImagesList
            If rImgs.Count > 0 Then
            %>
            <table class="<%= CssClassImagesVertical %>">
                <tr>
                    <td class="space">&nbsp;</td>
                    <% 
                        For I = 1 To rImgs.Count
                            imgSrc = VirtPath("/image.asp") & "?image=" & rImgs(I)("SID")
                            %>
                            <td class="thumbnail">
                                <a href="<%= imgSrc %>" target="_blank"><img src="<%= imgSrc & "&th=4" %>" border="0" alt="" width="<%= ThumbNailSizeIconSmall %>"/></a>
                            </td>
                            <%
                        Next
                    %>
                </tr>
            </table>
            <%
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCImageAttachments(ctlName) 
        Set ctl = New UCImageAttachments ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCImageAttachments = ctl ' TO DO: Change the control name
    End Function

%>