<%@ Language="VBScript" CODEPAGE=1251 %>
<!-- #include file="aspctl/aspctl.asp" -->
<!-- #include file="includes/common.asp" -->
<%
    Dim cErrImageJpg
    ' cErrImageJpg = VirtPath("/usercontrols/UCSesImage/uc-image-errimage.jpg")
    
    Set cache = New CBinaryCache
    cache.DatabaseFile = ImageCache_DatabaseFile

    Public Function FormatIdFromContentType(ct)
        Select Case LCase(ct)
            Case "image/jpeg"
                FormatIdFromContentType = 3
            Case "image/png"
                FormatIdFromContentType = 4
            Case "image/gif"
                FormatIdFromContentType = 2
            Case "image/bmp"
                FormatIdFromContentType = 1
            Case "image/pjpeg"
                FormatIdFromContentType = 3
            Case "image/tiff"
                FormatIdFromContentType = 6
            Case "image/x-png"
                FormatIdFromContentType = 4
            Case "image/x-wmf"
                FormatIdFromContentType = 10
            Case "image/x-icon"
                FormatIdFromContentType = 5
            Case Else
                FormatIdFromContentType = 0
        End Select
    End Function
    Public Function ContentTypeFromFormatId(fid)
            Dim i
            i = ConvertTo(vbLong,fid)
            Select Case i
                case 2
                    ContentTypeFromFormatId = "image/gif"
                Case 3
                    ContentTypeFromFormatId = "image/jpeg"
                Case 4
                    ContentTypeFromFormatId = "image/png"
                Case 5
                    ContentTypeFromFormatId = "image/x-icon"
                Case 6
                    ContentTypeFromFormatId = "image/tiff"
                Case 10
                    ContentTypeFromFormatId = "image/x-wmf"
                Case Else
                    ContentTypeFromFormatId = Empty
            End Select
        End Function


    Dim isThumb
    Sub SendNoImage()
        Dim sfmain, f
        Set sfmain = Server.CreateObject("newObjects.utilctls.SFMain")
        If isThumb > 2 Then
            Set f = sfmain.OpenFile(Server.MapPath(ImageErrorIcon_Path),&H40)
        Else
            Set f = sfmain.OpenFile(Server.MapPath(ImageError_Path),&H40)
        End If
        Response.ContentType = "image/gif"
        Response.BinaryWrite f.ReadBin(f.Size)
        f.Close
    End Sub

    Function GetAbsUrl(imgId)
        Dim s
        GetAbsUrl = ""
        Set cfg = Database.DB.Execute("SELECT SMTP_SERVER FROM CONFIGURATION",1,1)
        If cfg.Count > 0 Then
            s = ConvertTo(vbString, cfg(1)(1))
            If Len(s) < 5 Then Exit Function
            If Right(s,1) <> "/" Then s = s & "/"
            GetAbsUrl =  s & "image.asp?noerr=1&image=" & imgId
        End If
    End Function

    Sub Main
        Dim WebImage, r, ri, rec, sf, file, I, binData, SubstituteUser
        Set WebImage = Server.CreateObject("newObjects.media.ImgManipulator")
        
        Dim imageStore
        Set imageStore = Create_CFileStore(MapPath(ImageStore_Path),ImageStore_NumDirs)
        
        Dim ImageId, imagePath, actAsUser, userId
        isThumb = 0
           
        If ASPENCRYPTED.Count > 0 Then
            ' Replace the ID
            actAsUser = ConvertTo(vbString, ASPENCRYPTED("actas")) ' ActAsUser ***
            imageId = ConvertTo(vbString, ASPENCRYPTED("image"))
            isThumb = ConvertTo(vbLong, ASPENCRYPTED("th"))
        Else
            imageId = ConvertTo(vbLong, ASPALL("image"))
            isThumb = ConvertTo(vbLong, ASPALL("th"))
            userId = ConvertTo(vbString, ASPALL("user"))
        End If
        
        If imageId = 0 And Len(userId) <> 0 Then
            Set r = Database.DB.VExecute("SELECT IMAGE_SID FROM PERSON WHERE SID IN (SELECT PERSON_SID FROM USER WHERE ID=$USER_ID OR LOGIN=$LOGIN)",1,1,_
                                            NullConvertTo(vbLong, userId), NullConvertTo(vbString, userId))
            If r.Count > 0 Then
                imageId = ConvertTo(vbLong, r(1)(1))
            End If                                            
        End If
        
        If ImageId = 0 Then
            SendNoImage
            Exit Sub
        End If
        
        If Len(actAsUser) > 0 Then
            Set SubstituteUser = New CUser
            If SubstituteUser.Load(actAsUser) Then
                Set r = Database.DB.VExecute("SELECT CONTENT_TYPE, WIDTH, HEIGHT, PATH FROM IMAGE WHERE SID=$iid AND NOT DELETED AND " & _
                                             SQLReadRights, 1, 1, imageId)
            Else
                ' Attempt with current user rights instead of issuing an error (there is a chance the current user may have the rights to view the image)
                Set r = Database.DB.VExecute("SELECT CONTENT_TYPE, WIDTH, HEIGHT, PATH FROM IMAGE WHERE SID=$iid AND NOT DELETED AND " & _
                                         SQLReadRights, 1, 1, imageId)
            End If
        Else
            Set r = Database.DB.VExecute("SELECT CONTENT_TYPE, WIDTH, HEIGHT, PATH FROM IMAGE WHERE SID=$iid AND NOT DELETED AND " & _
                                         SQLReadRights, 1, 1, imageId)
        End If
                                
        If r.Count = 0 Then
            SendNoImage
            Exit Sub
        End If
        
        Set rec = r(1)
        
        imagePath = ConvertTo(vbString, rec("PATH"))
        
        If (Len(imagePath) = 0) Or IsNull(NullConvertTo(vbString,rec("CONTENT_TYPE"))) Then
            SendNoImage
            Exit Sub
        End If
        
        Dim sWidth, sHeight ' For future extensions
        sWidth = 0
        sHeight = 0        
        
        Dim tempSize
        
        If isThumb <> 0 Then
            ' Size correction has been requested
            binData = cache.Element(ImageId, isThumb)
            If Not IsNull(binData) Then
                Response.ContentType = ConvertTo(vbString, rec("CONTENT_TYPE"))
                Response.BinaryWrite binData
            Else
                
                If Not imageStore.FileAvailable(GetAbsUrl(imageId),imagePath,False) Then
                    SendNoImage
                    Exit Sub
                End If
                Set file = imageStore.ReadFile(imagePath)
                WebImage.AddImage file.ReadBin(file.Size), ConvertTo(vbString, rec("CONTENT_TYPE"))
                file.Close
                
                If WebImage.ImageCount > 0 Then
                    Response.ContentType = ConvertTo(vbString, rec("CONTENT_TYPE"))
                    On Error Resume Next
                    If isThumb = 1 Or isThumb = 3 Then
                        binData = WebImage.GetThumbnail(-1, IfThenElse(isThumb > 2,ThumbnailSizeIcon,ThumbnailSize), FormatIdFromContentType(ConvertTo(vbString, rec("CONTENT_TYPE"))))
                        cache.Element(ImageId, isThumb) = binData
                        Response.BinaryWrite binData
                    ElseIf isThumb = 2 Or isThumb = 4 Then
                        tempSize = IfThenElse(isThumb > 2,ThumbnailSizeIconSmall,ThumbnailSizeSmall)
                        If ResizeKeepingAspectRatio(WebImage, tempSize, tempSize, True) Then
                            binData = WebImage.GetImage(-1, FormatIdFromContentType(ConvertTo(vbString, rec("CONTENT_TYPE"))))
                            cache.Element(ImageId, isThumb) = binData
                            Response.BinaryWrite binData
                        Else
                            binData = WebImage.GetThumbnail(-1, tempSize, FormatIdFromContentType(ConvertTo(vbString, rec("CONTENT_TYPE"))))
                            cache.Element(ImageId, isThumb) = binData
                            Response.BinaryWrite binData
                        End If
                    End If
                    If Err.Number <> 0 Then
                        SendNoImage
                    End If
                End If
            End If
        ElseIf (sWidth > 0 Or sHeight > 0) Then
            If Not imageStore.FileAvailable(GetAbsUrl(imageId),imagePath,False) Then
                SendNoImage
                Exit Sub
            End If
            Set file = imageStore.ReadFile(imagePath)
            WebImage.AddImage file.ReadBin(file.Size), ConvertTo(vbString, rec("CONTENT_TYPE"))
            file.Close
            If ResizeKeepingAspectRatio(WebImage, sWidth, sHeight, True) Then
                Response.ContentType = ConvertTo(vbString, rec("CONTENT_TYPE"))
                binData = WebImage.GetImage(-1, FormatIdFromContentType(ConvertTo(vbString, rec("CONTENT_TYPE"))))
                Response.BinaryWrite binData
            Else
                SendNoImage
            End If
        Else
            
            ' Send the image "as is"
            If Not imageStore.FileAvailable(GetAbsUrl(imageId),imagePath,False) Then
                SendNoImage
                Exit Sub
            End If
            Response.ContentType = ConvertTo(vbString, rec("CONTENT_TYPE"))
            Set file = imageStore.ReadFile(imagePath)
            Response.BinaryWrite file.ReadBin(file.Size)
            file.Close
        End If
    End Sub
    
    Main
%>