<!-- #include file="master-common.asp" -->
<!-- #include file="../usercontrols/uc-errormessages.asp" -->
<%
MasterCancelProcessing = False

If PageRequiresAdmin Then
    If Not IsAdmin Then MasterCancelProcessing = True
End If
If PageLoginRequired Then
    If Not IsLoggedOn Then MasterCancelProcessing = True
End If
If Len(Application("Database")) = 0 Then
    MasterCancelProcessing = True
    ASPRedirect = VirtPath("/start.asp")
End If

PageStyleSheet = VirtPath("/styles.css")

' MASTER CONTROLS
Set uLogin = New UCLogin
uLogin.CssClass = "dropDownSelector"
Set uGlobalErrorMessages = Create_UCErrorMessages(Empty)
Set uGlobalErrorMessages.Database = Database

ClientScripts.StopPropagation uLogin, "click"

Set cMasterBtnMenu = Create_UCButtonMenu(Empty)
cMasterBtnMenu.CssClass = "dropDownSelector"
cMasterBtnMenu.Style = "width:200px;"
cMasterBtnMenu.Transition = "Appear"
cMasterBtnMenu.ButtonContent = "<a href="""">" & IfThenElse(IsLoggedOn,TR("Logged on"),TR("Anonymous")) & "</a>"
' Set cMasterBtnMenu.DropControl = Create_UCLinkPanel(Empty)
If Not PageIsMainLogin Then
    Set cMasterBtnMenu.DropControl = uLogin
    cMasterBtnMenu.DropControl.CssClass = "dropDownSelector"
End If    

Set MasterLanguageSwitch = New UCLanguage
MasterLanguageSwitch.Label = TR("Language")
MasterLanguageSwitch.Style = "width:100%;"

'Set cardMenu = New UCVerticalTabMenu
' cardMenu.SkinId = "Entry"


ApplySkin

Sub RenderMaster
Begin_Page Empty ' This routine takes care for the whole head of the page - meta, keywords, link, title and so on.
' TO DO: Add the design below and place the standard elements where you want them
%>
      <% Begin_PostBackForm("") %>
      <center>
      <table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%" class="pageFrame">
      <tr>
        <td width="100%" class="pageTitle"><%= PageTitle %></td>
      </tr>
      <tr>
        <tr>
        <td width="100%" width="100%">
          <table border="0" width="100%" cellspacing="0" cellpadding="0" class="topmenu" style="width:100%;">
            <tr>
              <td nowrap style="width:100%;">
                <ul class="topmenu">
                    <li class="icon"><a href="<%= VirtPath("/") %>"><img src="<%= VirtPath("/img/home_grey.png") %>" border="0" alt="" /></a></li>
                    <li><a href="<%= VirtPath("/") %>"><%= TR("Home") %></a></li>
                </ul>
                <!-- #include file="master-adminmenu-top.asp" -->
              </td>
              <td nowrap><% MasterLanguageSwitch.Render %></td>
              <td align="right" style="text-align:right;"><% If Not PageIsMainLogin Then cMasterBtnMenu.Render %></td>
            </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td width="100%" height="100%" valign="top" class="workArea">
          <table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
            <tr>
              <td width="200" valign="top" style="vertical-align: top;" class="entryLeftPanel">
                <% If PageIsMainLogin Then uLogin.Render %>
                <!-- #include file="master-menu-top.asp" -->
                <!-- #include file="master-adminmenu-left.asp" -->
                
              </td>
              <td valign="top" style="vertical-align: top;">
                <% uGlobalErrorMessages.Render %>
                <% RenderPage %>
              </td>
            </tr>
          </table>
        </td>
    </tr>
    <tr>
        <td width="100%">
          <table width="100%" cellspacing="0" cellpadding="0" class="masterfooter">
            <tr>
              <td align="middle">
                Copyright &copy; [Archeological authority]
              </td>
            </tr>
          </table>    
        </td>
    </tr>
    </table>
    </center>
    <% End_PostBackForm %>
    <% hint.Render %>
<%
' TO DO: Uncomment temporarily if you need tracing and summary information to be displayed at the bottom of the page.
' DumpRequest
End_Page
End Sub

MasterLanguageSwitch.MasterProcessPage
uLogin.MasterProcessPage

StandardMasterPageProcessing VirtPath("/start.asp")

%>
