-- PATCH FROM VERSION 2 TO VERSION 3
-- VERSION
DELETE FROM DBVERSION;INSERT INTO DBVERSION ([VER]) VALUES (3);
  -- UNCHANGED TABLE IPACTION
  -- END UNCHANGED TABLE IPACTION

  -- UNCHANGED TABLE CONFIGURATION
  -- END UNCHANGED TABLE CONFIGURATION

  -- UNCHANGED TABLE SYS
  -- END UNCHANGED TABLE SYS

  -- UNCHANGED TABLE TSYS
  -- END UNCHANGED TABLE TSYS

  -- UNCHANGED TABLE USER
  -- END UNCHANGED TABLE USER

  -- UNCHANGED TABLE USER_ACCESSDEFAULTS
  -- END UNCHANGED TABLE USER_ACCESSDEFAULTS

  -- UNCHANGED TABLE USER_SERVICES
  -- END UNCHANGED TABLE USER_SERVICES

  -- UNCHANGED TABLE USER_NOTIFY
  -- END UNCHANGED TABLE USER_NOTIFY

  -- UNCHANGED TABLE USER_QUOTAS
  -- END UNCHANGED TABLE USER_QUOTAS

  -- UNCHANGED TABLE USER_DELTA_QUOTAS
  -- END UNCHANGED TABLE USER_DELTA_QUOTAS

  -- UNCHANGED TABLE S_GROUP
  -- END UNCHANGED TABLE S_GROUP

  -- UNCHANGED TABLE GROUP_ACCESSDEFAULTS
  -- END UNCHANGED TABLE GROUP_ACCESSDEFAULTS

  -- UNCHANGED TABLE GROUP_SERVICES
  -- END UNCHANGED TABLE GROUP_SERVICES

  -- UNCHANGED TABLE GROUP_NOTIFY
  -- END UNCHANGED TABLE GROUP_NOTIFY

  -- UNCHANGED TABLE GROUP_QUOTAS
  -- END UNCHANGED TABLE GROUP_QUOTAS

  -- UNCHANGED TABLE GROUP_DELTA_QUOTAS
  -- END UNCHANGED TABLE GROUP_DELTA_QUOTAS

  -- UNCHANGED TABLE PERSON
  -- END UNCHANGED TABLE PERSON

  -- UNCHANGED TABLE EXPOSITION
  -- END UNCHANGED TABLE EXPOSITION

  -- UNCHANGED TABLE ACCESSIBILITY
  -- END UNCHANGED TABLE ACCESSIBILITY

  -- UNCHANGED TABLE OBSERVABILITY
  -- END UNCHANGED TABLE OBSERVABILITY

  -- UNCHANGED TABLE SLOPE
  -- END UNCHANGED TABLE SLOPE

  -- UNCHANGED TABLE CONCENTRATION
  -- END UNCHANGED TABLE CONCENTRATION

  -- UNCHANGED TABLE GROUPING
  -- END UNCHANGED TABLE GROUPING

  -- UNCHANGED TABLE PROTECTION
  -- END UNCHANGED TABLE PROTECTION

  -- UNCHANGED TABLE OWNERSHIP
  -- END UNCHANGED TABLE OWNERSHIP

  -- UNCHANGED TABLE TERRAINUSAGE
  -- END UNCHANGED TABLE TERRAINUSAGE

  -- UNCHANGED TABLE GUARD
  -- END UNCHANGED TABLE GUARD

  -- UNCHANGED TABLE IMPORTANCE
  -- END UNCHANGED TABLE IMPORTANCE

  -- UNCHANGED TABLE ENVIRONMENT
  -- END UNCHANGED TABLE ENVIRONMENT

  -- UNCHANGED TABLE PRESERVATION
  -- END UNCHANGED TABLE PRESERVATION

  -- UNCHANGED TABLE SOCIALIZATION
  -- END UNCHANGED TABLE SOCIALIZATION

  -- UNCHANGED TABLE USAGEREGIME
  -- END UNCHANGED TABLE USAGEREGIME

  -- UNCHANGED TABLE STATUS
  -- END UNCHANGED TABLE STATUS

  -- UNCHANGED TABLE HELP
  -- END UNCHANGED TABLE HELP

  -- UNCHANGED TABLE SOIL_TYPE
  -- END UNCHANGED TABLE SOIL_TYPE

  -- UNCHANGED TABLE GEOFORM
  -- END UNCHANGED TABLE GEOFORM

  -- UNCHANGED TABLE TYPE
  -- END UNCHANGED TABLE TYPE

  -- UNCHANGED TABLE CHRONOLOGY
  -- END UNCHANGED TABLE CHRONOLOGY

  -- UNCHANGED TABLE FACILITY
  -- END UNCHANGED TABLE FACILITY

  -- UNCHANGED TABLE FINDING
  -- END UNCHANGED TABLE FINDING

  -- UNCHANGED TABLE HYDROGRAPHY
  -- END UNCHANGED TABLE HYDROGRAPHY

  -- UNCHANGED TABLE OROGRAPHY
  -- END UNCHANGED TABLE OROGRAPHY

  -- UNCHANGED TABLE LOCATION
  -- END UNCHANGED TABLE LOCATION

  -- UNCHANGED TABLE LOCATION_TYPE
  -- END UNCHANGED TABLE LOCATION_TYPE

  -- UNCHANGED TABLE MAIL_TEMPLATE
  -- END UNCHANGED TABLE MAIL_TEMPLATE

  -- CHANGE TABLE CARD
  CREATE TABLE [PATCH_TEMP_CARD] AS SELECT * FROM [CARD];
  DROP TABLE [CARD];
  CREATE TABLE CARD(
        [SID] INTEGER NOT NULL,
        [CREATED] DATETIME,
        [MODIFIED] DATETIME,
        [MODIFY_USER_ID] INTEGER,
        [OWNER_USER_ID] INTEGER,
        [OWNER_GROUP_ID] INTEGER,
        [R_USER] INTEGER DEFAULT 7,
        [R_GROUP] INTEGER DEFAULT 3,
        [R_ALL] INTEGER DEFAULT 1,
        [DELETED] BOOLEAN DEFAULT 0,
        [CHANGED] BOOLEAN DEFAULT -1,
        [LANGUAGE] TEXT NOT NULL,
        
        [LOCATION_SID] INTEGER ,
        [OWNERSHIP_SID] INTEGER ,
        [TERRAINUSAGE_SID] INTEGER ,
        [GEOFORM_SID] INTEGER ,
        [OROGRAPHY_SID] INTEGER ,
        [HYDROGRAPHY_SID] INTEGER ,
        [SOIL_TYPES_SID] INTEGER ,
        [EXPOSITION_SID] INTEGER ,
        [ACCESSIBILITY_SID] INTEGER ,
        [OBSERVABILITY_SID] INTEGER ,
        [SLOPE_SID] INTEGER ,
        [CONCENTRATION_SID] INTEGER ,
        [GROUPING_SID] INTEGER ,
        [PROTECTION_SID] INTEGER ,
        [IMPORTANCE_SID] INTEGER ,
        [GUARD_SID] INTEGER ,
        [ENVIRONMENT_SID] INTEGER ,
        [PRESERVATION_SID] INTEGER ,
        [PARENT_CARD_SID] INTEGER ,
        [MAP_SCALE] INTEGER ,
        [PLACE_ADDRESS] TEXT ,
        [MAP_CREATOR_PERSON_SID] INTEGER ,
        [MAP_DATE] DATETIME ,
        [RELATIVE_LOCALIZATION] TEXT ,
        [ELEVATION] INTEGER ,
        [ARCHIVE_INFO] TEXT ,
        [MUSEUM_INFO] TEXT ,
        [OTHER_INFO] TEXT ,
        [AREA] NUMERIC ,
        [SPECIFICS] TEXT ,
        [PLOT_SCALE] INTEGER ,
        [PLOT_CREATOR_PERSON_SID] INTEGER ,
        [PLOT_DATE] DATETIME ,
        [BELONG_COMPLEX] TEXT ,
        [BELONG_SYSTEM] TEXT ,
        [BELONG_CULTURE] TEXT ,
        [RESEARCH_HISTORY] TEXT ,
        [PROTECTION_COMMENT] TEXT ,
        [COMMENTS] TEXT ,
        [CREATOR_PERSON_SID] INTEGER ,
        [CHECKED_PERSON_SID] INTEGER ,
        [CREATED_DATE] DATETIME ,
        [OBJECT_NUMBER] TEXT ,
        [CARD_NUMBER] TEXT, -- Generated on completion or confirmation
        [COMPLETED] INTEGER DEFAULT 0,
        [ELEVATION2] INTEGER ,
        [SOCIALIZATION_SID] INTEGER ,
        [USAGEREGIME_SID] INTEGER ,
        [LATITUDE] DOUBLE ,
        [LONGITUDE] DOUBLE ,
        [CADCODE] TEXT , -- Reserved
        [PLOT_IMAGE_SID] INTEGER ,
        [MAP_IMAGE_SID] INTEGER ,
        [STATUS_SID] INTEGER , -- Cache
        [STATUS_COMMENTS] TEXT , -- Cache
        [STATUS_PERSON_SID] INTEGER , -- Cache
        [PUBLICATIONS_INFO] TEXT,
        
        [OBJECT_NAME] TEXT, -- A name for the object (work name or official)
        [OBJECT_DESCRIPTION] TEXT, -- Free textual description of the object (very optional)
        PRIMARY KEY (SID, LANGUAGE) ON CONFLICT REPLACE
    );
  INSERT INTO [CARD] ([SID],[CREATED],[MODIFIED],[MODIFY_USER_ID],[OWNER_USER_ID],[OWNER_GROUP_ID],[R_USER],[R_GROUP],[R_ALL],[DELETED],[CHANGED],[LANGUAGE],[LOCATION_SID],[OWNERSHIP_SID],[TERRAINUSAGE_SID],[GEOFORM_SID],[OROGRAPHY_SID],[HYDROGRAPHY_SID],[SOIL_TYPES_SID],[EXPOSITION_SID],[ACCESSIBILITY_SID],[OBSERVABILITY_SID],[SLOPE_SID],[CONCENTRATION_SID],[GROUPING_SID],[PROTECTION_SID],[IMPORTANCE_SID],[GUARD_SID],[ENVIRONMENT_SID],[PRESERVATION_SID],[PARENT_CARD_SID],[MAP_SCALE],[PLACE_ADDRESS],[MAP_CREATOR_PERSON_SID],[MAP_DATE],[RELATIVE_LOCALIZATION],[ELEVATION],[ARCHIVE_INFO],[MUSEUM_INFO],[OTHER_INFO],[AREA],[SPECIFICS],[PLOT_SCALE],[PLOT_CREATOR_PERSON_SID],[PLOT_DATE],[BELONG_COMPLEX],[BELONG_SYSTEM],[BELONG_CULTURE],[RESEARCH_HISTORY],[PROTECTION_COMMENT],[COMMENTS],[CREATOR_PERSON_SID],[CHECKED_PERSON_SID],[CREATED_DATE],[OBJECT_NUMBER],[CARD_NUMBER],[COMPLETED],[ELEVATION2],[SOCIALIZATION_SID],[USAGEREGIME_SID],[LATITUDE],[LONGITUDE],[CADCODE],[PLOT_IMAGE_SID],[MAP_IMAGE_SID],[STATUS_SID],[STATUS_COMMENTS],[STATUS_PERSON_SID],[PUBLICATIONS_INFO]) SELECT [SID],[CREATED],[MODIFIED],[MODIFY_USER_ID],[OWNER_USER_ID],[OWNER_GROUP_ID],[R_USER],[R_GROUP],[R_ALL],[DELETED],[CHANGED],[LANGUAGE],[LOCATION_SID],[OWNERSHIP_SID],[TERRAINUSAGE_SID],[GEOFORM_SID],[OROGRAPHY_SID],[HYDROGRAPHY_SID],[SOIL_TYPES_SID],[EXPOSITION_SID],[ACCESSIBILITY_SID],[OBSERVABILITY_SID],[SLOPE_SID],[CONCENTRATION_SID],[GROUPING_SID],[PROTECTION_SID],[IMPORTANCE_SID],[GUARD_SID],[ENVIRONMENT_SID],[PRESERVATION_SID],[PARENT_CARD_SID],[MAP_SCALE],[PLACE_ADDRESS],[MAP_CREATOR_PERSON_SID],[MAP_DATE],[RELATIVE_LOCALIZATION],[ELEVATION],[ARCHIVE_INFO],[MUSEUM_INFO],[OTHER_INFO],[AREA],[SPECIFICS],[PLOT_SCALE],[PLOT_CREATOR_PERSON_SID],[PLOT_DATE],[BELONG_COMPLEX],[BELONG_SYSTEM],[BELONG_CULTURE],[RESEARCH_HISTORY],[PROTECTION_COMMENT],[COMMENTS],[CREATOR_PERSON_SID],[CHECKED_PERSON_SID],[CREATED_DATE],[OBJECT_NUMBER],[CARD_NUMBER],[COMPLETED],[ELEVATION2],[SOCIALIZATION_SID],[USAGEREGIME_SID],[LATITUDE],[LONGITUDE],[CADCODE],[PLOT_IMAGE_SID],[MAP_IMAGE_SID],[STATUS_SID],[STATUS_COMMENTS],[STATUS_PERSON_SID],[PUBLICATIONS_INFO] FROM [PATCH_TEMP_CARD];
  DROP TABLE [PATCH_TEMP_CARD];
CREATE INDEX CARD_IDX_CREATED ON CARD(CREATED);
CREATE INDEX CARD_IDX_MODIFIED ON CARD(MODIFIED);
CREATE INDEX CARD_IDX_MODIFY_USER_ID ON CARD(MODIFY_USER_ID);
CREATE INDEX CARD_IDX_OWNER_USER_ID ON CARD(OWNER_USER_ID);
CREATE INDEX CARD_IDX_OWNER_GROUP_ID ON CARD(OWNER_GROUP_ID);
CREATE INDEX CARD_IDX_R_USER ON CARD(R_USER);
CREATE INDEX CARD_IDX_R_GROUP ON CARD(R_GROUP);
CREATE INDEX CARD_IDX_R_ALL ON CARD(R_ALL);
CREATE INDEX CARD_IDX_DELETED ON CARD(DELETED);
CREATE INDEX CARD_IDX_CHANGED ON CARD(CHANGED);
CREATE INDEX CARD_IDX_LANGUAGE ON CARD(LANGUAGE);
CREATE INDEX CARD_IDX_LOCATION_SID ON CARD(LOCATION_SID);
CREATE INDEX CARD_IDX_OWNERSHIP_SID ON CARD(OWNERSHIP_SID);
CREATE INDEX CARD_IDX_TERRAINUSAGE_SID ON CARD(TERRAINUSAGE_SID);
CREATE INDEX CARD_IDX_GEOFORM_SID ON CARD(GEOFORM_SID);
CREATE INDEX CARD_IDX_OROGRAPHY_SID ON CARD(OROGRAPHY_SID);
CREATE INDEX CARD_IDX_HYDROGRAPHY_SID ON CARD(HYDROGRAPHY_SID);
CREATE INDEX CARD_IDX_SOIL_TYPES_SID ON CARD(SOIL_TYPES_SID);
CREATE INDEX CARD_IDX_EXPOSITION_SID ON CARD(EXPOSITION_SID);
CREATE INDEX CARD_IDX_ACCESSIBILITY_SID ON CARD(ACCESSIBILITY_SID);
CREATE INDEX CARD_IDX_OBSERVABILITY_SID ON CARD(OBSERVABILITY_SID);
CREATE INDEX CARD_IDX_SLOPE_SID ON CARD(SLOPE_SID);
CREATE INDEX CARD_IDX_CONCENTRATION_SID ON CARD(CONCENTRATION_SID);
CREATE INDEX CARD_IDX_GROUPING_SID ON CARD(GROUPING_SID);
CREATE INDEX CARD_IDX_PROTECTION_SID ON CARD(PROTECTION_SID);
CREATE INDEX CARD_IDX_IMPORTANCE_SID ON CARD(IMPORTANCE_SID);
CREATE INDEX CARD_IDX_GUARD_SID ON CARD(GUARD_SID);
CREATE INDEX CARD_IDX_ENVIRONMENT_SID ON CARD(ENVIRONMENT_SID);
CREATE INDEX CARD_IDX_PRESERVATION_SID ON CARD(PRESERVATION_SID);
CREATE INDEX CARD_IDX_PARENT_CARD_SID ON CARD(PARENT_CARD_SID);
CREATE INDEX CARD_IDX_PARENT_MAP_SCALE ON CARD(MAP_SCALE);
CREATE INDEX CARD_IDX_MAP_CREATOR_PERSON_SID ON CARD(MAP_CREATOR_PERSON_SID);
CREATE INDEX CARD_IDX_MAP_DATE ON CARD(MAP_DATE);
CREATE INDEX CARD_IDX_ELEVATION ON CARD(ELEVATION);
CREATE INDEX CARD_IDX_AREA ON CARD(AREA);
CREATE INDEX CARD_IDX_PLOT_SCALE ON CARD(PLOT_SCALE);
CREATE INDEX CARD_IDX_PLOT_CREATOR_PERSON_SID ON CARD(PLOT_CREATOR_PERSON_SID);
CREATE INDEX CARD_IDX_PLOT_DATE ON CARD(PLOT_DATE);
CREATE INDEX CARD_IDX_CREATOR_PERSON_SID ON CARD(CREATOR_PERSON_SID);
CREATE INDEX CARD_IDX_CHECKED_PERSON_SID ON CARD(CHECKED_PERSON_SID);
CREATE INDEX CARD_IDX_CREATED_DATE ON CARD(CREATED_DATE);
CREATE INDEX CARD_IDX_OBJECT_NUMBER ON CARD(OBJECT_NUMBER);
CREATE INDEX CARD_IDX_CARD_NUMBER ON CARD(CARD_NUMBER);
CREATE INDEX CARD_IDX_COMPLETED ON CARD(COMPLETED);
CREATE INDEX CARD_IDX_ELEVATION2 ON CARD(ELEVATION2);
CREATE INDEX CARD_IDX_SOCIALIZATION_SID ON CARD(SOCIALIZATION_SID);
CREATE INDEX CARD_IDX_USAGEREGIME_SID ON CARD(USAGEREGIME_SID);
CREATE INDEX CARD_IDX_LATITUDE ON CARD(LATITUDE);
CREATE INDEX CARD_IDX_LONGITUDE ON CARD(LONGITUDE);
CREATE INDEX CARD_IDX_PLOT_IMAGE_SID ON CARD(PLOT_IMAGE_SID);
CREATE INDEX CARD_IDX_MAP_IMAGE_SID ON CARD(MAP_IMAGE_SID);
CREATE INDEX CARD_IDX_STATUS_SID ON CARD(STATUS_SID);
CREATE INDEX CARD_IDX_STATUS_PERSON_SID ON CARD(STATUS_PERSON_SID);
CREATE INDEX CARD_IDX_OBJECT_NAME ON CARD(OBJECT_NAME);
CREATE INDEX CARD_IDX_OBJECT_DESCRIPTION ON CARD(OBJECT_DESCRIPTION);
  -- UNCHANGED TABLE CARD_TYPE_CHRONOLOGY_REL
  -- END UNCHANGED TABLE CARD_TYPE_CHRONOLOGY_REL

  -- UNCHANGED TABLE CARD_FACILITY_REL
  -- END UNCHANGED TABLE CARD_FACILITY_REL

  -- UNCHANGED TABLE CARD_FINDING_REL
  -- END UNCHANGED TABLE CARD_FINDING_REL

  -- UNCHANGED TABLE BORDER_POINT
  -- END UNCHANGED TABLE BORDER_POINT

  -- UNCHANGED TABLE CARD_IMAGE
  -- END UNCHANGED TABLE CARD_IMAGE

  -- UNCHANGED TABLE CARD_CORRECTION
  -- END UNCHANGED TABLE CARD_CORRECTION

  -- UNCHANGED TABLE CARD_LOCATIONS
  -- END UNCHANGED TABLE CARD_LOCATIONS

  -- UNCHANGED TABLE IMAGE_TYPE
  -- END UNCHANGED TABLE IMAGE_TYPE

  -- UNCHANGED TABLE IMAGE
  -- END UNCHANGED TABLE IMAGE

  -- UNCHANGED TABLE FILE
  -- END UNCHANGED TABLE FILE

  -- UNCHANGED TABLE KEYWORD
  -- END UNCHANGED TABLE KEYWORD

  -- UNCHANGED TABLE OBJECT_KEYWORD
  -- END UNCHANGED TABLE OBJECT_KEYWORD

  -- UNCHANGED TABLE RELATION
  -- END UNCHANGED TABLE RELATION

  -- UNCHANGED TABLE CARD_NUMBERING
  -- END UNCHANGED TABLE CARD_NUMBERING

  -- UNCHANGED TABLE MESSAGES
  -- END UNCHANGED TABLE MESSAGES

  -- CHANGE TABLE CARD_FILTER
  CREATE TABLE [PATCH_TEMP_CARD_FILTER] AS SELECT * FROM [CARD_FILTER];
  DROP TABLE [CARD_FILTER];
  CREATE TABLE CARD_FILTER(
        [SID] INTEGER NOT NULL,
        [CREATED] DATETIME,
        [MODIFIED] DATETIME,
        [MODIFY_USER_ID] INTEGER,
        [OWNER_USER_ID] INTEGER,
        [OWNER_GROUP_ID] INTEGER,
        [R_USER] INTEGER DEFAULT 7,
        [R_GROUP] INTEGER DEFAULT 3,
        [R_ALL] INTEGER DEFAULT 1,
        [DELETED] BOOLEAN DEFAULT 0,
        [CHANGED] BOOLEAN DEFAULT -1,
        [LANGUAGE] TEXT, -- Kept for compatibility with language split solutions (none planned, but just in case)
        
        -- ID based
        [LOCATION_SID] INTEGER ,
        [OWNERSHIP_SID] INTEGER ,
        [TERRAINUSAGE_SID] INTEGER ,
        [GEOFORM_SID] INTEGER ,
        [OROGRAPHY_SID] INTEGER ,
        [HYDROGRAPHY_SID] INTEGER ,
        [SOIL_TYPES_SID] INTEGER ,
        [EXPOSITION_SID] INTEGER ,
        [ACCESSIBILITY_SID] INTEGER ,
        [OBSERVABILITY_SID] INTEGER ,
        [SLOPE_SID] INTEGER ,
        [CONCENTRATION_SID] INTEGER ,
        [GROUPING_SID] INTEGER ,
        [PROTECTION_SID] INTEGER ,
        [IMPORTANCE_SID] INTEGER ,
        [GUARD_SID] INTEGER ,
        [ENVIRONMENT_SID] INTEGER ,
        [PRESERVATION_SID] INTEGER ,
        [SOCIALIZATION_SID] INTEGER ,
        [USAGEREGIME_SID] INTEGER ,
        [STATUS_SID] INTEGER ,
        
        -- Special
        [PARENT_CARD_SID] INTEGER ,
        [PERSON_SID] INTEGER ,
        [CARD_NUMBER] TEXT, -- Generated on completion or confirmation
        [COMPLETED] INTEGER DEFAULT 0,
        
        
        -- ID Containment
        [TYPE_SID] INTEGER,
        [CHRONOLOGY_SID] INTEGER,
        [FACILITY_SID] INTEGER,
        [FINDING_SID] INTEGER,
        
        -- Pattern
        [PATTERN] TEXT,
        [OBJECT_NUMBER] TEXT ,
        
        -- Ranges
        [CREATED_DATE_MIN] DATETIME ,
        [CREATED_DATE_MAX] DATETIME ,
        [MODIFIED_DATE_MIN] DATETIME ,
        [MODIFIED_DATE_MAX] DATETIME ,
        [MAP_SCALE_MIN] INTEGER , -- NOT IMPL
        [MAP_SCALE_MAX] INTEGER , -- NOT IMPL
        [PLOT_SCALE_MIN] INTEGER , -- NOT IMPL
        [PLOT_SCALE_MAX] INTEGER , -- NOT IMPL
        [ELEVATION_MIN] INTEGER ,
        [ELEVATION_MAX] INTEGER ,
        [AREA_MIN] NUMERIC ,
        [AREA_MAX] NUMERIC ,
        
        -- Geo
        [LATITUDE] DOUBLE ,
        [LONGITUDE] DOUBLE ,
        [GEO_RANGE] DOUBLE DEFAULT 0.05,
        
        [CADCODE] TEXT , -- Reserved
        
        [FILTER_NAME] TEXT ,
        
        [HASMAP] BOOLEAN ,
        [HASPLOT] BOOLEAN ,
        [HASIMAGES] BOOLEAN ,
        [HASFILES] BOOLEAN ,
        [ISROOTOBJECT] BOOLEAN,
        [ISNOTROOTOBJECT] BOOLEAN,
        PRIMARY KEY (SID, LANGUAGE) ON CONFLICT REPLACE
    );
  INSERT INTO [CARD_FILTER] ([SID],[CREATED],[MODIFIED],[MODIFY_USER_ID],[OWNER_USER_ID],[OWNER_GROUP_ID],[R_USER],[R_GROUP],[R_ALL],[DELETED],[CHANGED],[LANGUAGE],[LOCATION_SID],[OWNERSHIP_SID],[TERRAINUSAGE_SID],[GEOFORM_SID],[OROGRAPHY_SID],[HYDROGRAPHY_SID],[SOIL_TYPES_SID],[EXPOSITION_SID],[ACCESSIBILITY_SID],[OBSERVABILITY_SID],[SLOPE_SID],[CONCENTRATION_SID],[GROUPING_SID],[PROTECTION_SID],[IMPORTANCE_SID],[GUARD_SID],[ENVIRONMENT_SID],[PRESERVATION_SID],[SOCIALIZATION_SID],[USAGEREGIME_SID],[STATUS_SID],[PARENT_CARD_SID],[PERSON_SID],[CARD_NUMBER],[COMPLETED],[TYPE_SID],[CHRONOLOGY_SID],[FACILITY_SID],[FINDING_SID],[PATTERN],[OBJECT_NUMBER],[CREATED_DATE_MIN],[CREATED_DATE_MAX],[MODIFIED_DATE_MIN],[MODIFIED_DATE_MAX],[MAP_SCALE_MIN],[MAP_SCALE_MAX],[PLOT_SCALE_MIN],[PLOT_SCALE_MAX],[ELEVATION_MIN],[ELEVATION_MAX],[AREA_MIN],[AREA_MAX],[LATITUDE],[LONGITUDE],[GEO_RANGE],[CADCODE],[FILTER_NAME],[HASMAP],[HASPLOT],[HASIMAGES],[HASFILES],[ISROOTOBJECT],[ISNOTROOTOBJECT]) SELECT [SID],[CREATED],[MODIFIED],[MODIFY_USER_ID],[OWNER_USER_ID],[OWNER_GROUP_ID],[R_USER],[R_GROUP],[R_ALL],[DELETED],[CHANGED],[LANGUAGE],[LOCATION_SID],[OWNERSHIP_SID],[TERRAINUSAGE_SID],[GEOFORM_SID],[OROGRAPHY_SID],[HYDROGRAPHY_SID],[SOIL_TYPES_SID],[EXPOSITION_SID],[ACCESSIBILITY_SID],[OBSERVABILITY_SID],[SLOPE_SID],[CONCENTRATION_SID],[GROUPING_SID],[PROTECTION_SID],[IMPORTANCE_SID],[GUARD_SID],[ENVIRONMENT_SID],[PRESERVATION_SID],[SOCIALIZATION_SID],[USAGEREGIME_SID],[STATUS_SID],[PARENT_CARD_SID],[PERSON_SID],[CARD_NUMBER],[COMPLETED],[TYPE_SID],[CHRONOLOGY_SID],[FACILITY_SID],[FINDING_SID],[PATTERN],[OBJECT_NUMBER],[CREATED_DATE_MIN],[CREATED_DATE_MAX],[MODIFIED_DATE_MIN],[MODIFIED_DATE_MAX],[MAP_SCALE_MIN],[MAP_SCALE_MAX],[PLOT_SCALE_MIN],[PLOT_SCALE_MAX],[ELEVATION_MIN],[ELEVATION_MAX],[AREA_MIN],[AREA_MAX],[LATITUDE],[LONGITUDE],[GEO_RANGE],[CADCODE],[FILTER_NAME],[HASMAP],[HASPLOT],[HASIMAGES],[HASFILES],[ISROOTOBJECT],[ISNOTROOTOBJECT] FROM [PATCH_TEMP_CARD_FILTER];
  DROP TABLE [PATCH_TEMP_CARD_FILTER];
CREATE INDEX CARD_FILTER_IDX_SID ON CARD_FILTER(SID);
CREATE INDEX CARD_FILTER_IDX_CREATED ON CARD_FILTER(CREATED);
CREATE INDEX CARD_FILTER_IDX_MODIFIED ON CARD_FILTER(MODIFIED);
CREATE INDEX CARD_FILTER_IDX_MODIFY_USER_ID ON CARD_FILTER(MODIFY_USER_ID);
CREATE INDEX CARD_FILTER_IDX_OWNER_USER_ID ON CARD_FILTER(OWNER_USER_ID);
CREATE INDEX CARD_FILTER_IDX_OWNER_GROUP_ID ON CARD_FILTER(OWNER_GROUP_ID);
CREATE INDEX CARD_FILTER_IDX_R_USER ON CARD_FILTER(R_USER);
CREATE INDEX CARD_FILTER_IDX_R_GROUP ON CARD_FILTER(R_GROUP);
CREATE INDEX CARD_FILTER_IDX_R_ALL ON CARD_FILTER(R_ALL);
CREATE INDEX CARD_FILTER_IDX_DELETED ON CARD_FILTER(DELETED);
CREATE INDEX CARD_FILTER_IDX_CHANGED ON CARD_FILTER(CHANGED);
CREATE INDEX CARD_FILTER_IDX_LANGUAGE ON CARD_FILTER(LANGUAGE);

  -- RECREATE VIEWS AND TRIGGERS
  DROP view [VCARD_RESULTS];
CREATE VIEW VCARD_RESULTS AS
    SELECT C.* 
    FROM CARD C, CARD_FILTER F
    WHERE F.SID=Parameter('FILTER_SID') AND
        C.LANGUAGE=Parameter('LANGUAGE') AND
        (F.OWNERSHIP_SID ISNULL OR F.OWNERSHIP_SID=C.OWNERSHIP_SID) AND
        (F.TERRAINUSAGE_SID ISNULL OR F.TERRAINUSAGE_SID=C.TERRAINUSAGE_SID) AND
        (F.GEOFORM_SID ISNULL OR F.GEOFORM_SID=C.GEOFORM_SID) AND
        (F.OROGRAPHY_SID ISNULL OR F.OROGRAPHY_SID=C.OROGRAPHY_SID) AND
        (F.HYDROGRAPHY_SID ISNULL OR F.HYDROGRAPHY_SID=C.HYDROGRAPHY_SID) AND
        (F.SOIL_TYPES_SID ISNULL OR F.SOIL_TYPES_SID=C.SOIL_TYPES_SID) AND
        (F.EXPOSITION_SID ISNULL OR F.EXPOSITION_SID=C.EXPOSITION_SID) AND
        (F.ACCESSIBILITY_SID ISNULL OR F.ACCESSIBILITY_SID=C.ACCESSIBILITY_SID) AND
        (F.OBSERVABILITY_SID ISNULL OR F.OBSERVABILITY_SID=C.OBSERVABILITY_SID) AND
        (F.SLOPE_SID ISNULL OR F.SLOPE_SID=C.SLOPE_SID) AND
        (F.CONCENTRATION_SID ISNULL OR F.CONCENTRATION_SID=C.CONCENTRATION_SID) AND
        (F.GROUPING_SID ISNULL OR F.GROUPING_SID=C.GROUPING_SID) AND
        (F.PROTECTION_SID ISNULL OR F.PROTECTION_SID=C.PROTECTION_SID) AND
        (F.IMPORTANCE_SID ISNULL OR F.IMPORTANCE_SID=C.IMPORTANCE_SID) AND
        (F.GUARD_SID ISNULL OR F.GUARD_SID=C.GUARD_SID) AND
        (F.ENVIRONMENT_SID ISNULL OR F.ENVIRONMENT_SID=C.ENVIRONMENT_SID) AND
        (F.PRESERVATION_SID ISNULL OR F.PRESERVATION_SID=C.PRESERVATION_SID) AND
        (F.SOCIALIZATION_SID ISNULL OR F.SOCIALIZATION_SID=C.SOCIALIZATION_SID) AND
        (F.USAGEREGIME_SID ISNULL OR F.USAGEREGIME_SID=C.USAGEREGIME_SID) AND
        (F.PARENT_CARD_SID ISNULL OR F.PARENT_CARD_SID=C.PARENT_CARD_SID) AND
        (F.STATUS_SID ISNULL OR F.STATUS_SID=C.STATUS_SID) AND
        (F.PERSON_SID ISNULL OR (F.PERSON_SID=C.MAP_CREATOR_PERSON_SID OR
                                 F.PERSON_SID=C.PLOT_CREATOR_PERSON_SID OR
                                 F.PERSON_SID=C.CREATOR_PERSON_SID OR
                                 F.PERSON_SID=C.CHECKED_PERSON_SID OR
                                 F.PERSON_SID=C.STATUS_PERSON_SID)) AND
        (F.OBJECT_NUMBER ISNULL OR F.OBJECT_NUMBER=C.OBJECT_NUMBER) AND
        (F.CARD_NUMBER ISNULL OR F.CARD_NUMBER=C.CARD_NUMBER) AND
        (F.CREATED_DATE_MIN ISNULL OR F.CREATED_DATE_MIN >=C.CREATED) AND
        (F.CREATED_DATE_MAX ISNULL OR F.CREATED_DATE_MAX <=C.CREATED) AND
        (F.MODIFIED_DATE_MIN ISNULL OR F.MODIFIED_DATE_MIN <=C.MODIFIED) AND
        (F.MODIFIED_DATE_MAX ISNULL OR F.MODIFIED_DATE_MAX <=C.MODIFIED) AND
        (F.ELEVATION_MIN ISNULL OR F.ELEVATION_MIN <= C.ELEVATION) AND
        (F.ELEVATION_MAX ISNULL OR (F.ELEVATION_MAX >= C.ELEVATION)) AND
        (F.AREA_MIN ISNULL OR F.AREA_MIN <= C.AREA) AND
        (F.AREA_MAX ISNULL OR F.AREA_MAX >= C.AREA) AND
        ((F.LATITUDE ISNULL AND F.LONGITUDE ISNULL) OR 
            (C.LATITUDE BETWEEN F.LATITUDE-GEO_RANGE AND F.LATITUDE+GEO_RANGE AND C.LONGITUDE BETWEEN F.LONGITUDE-GEO_RANGE AND F.LONGITUDE+GEO_RANGE)) AND
        (F.HASMAP ISNULL OR C.MAP_IMAGE_SID NOTNULL) AND 
        (F.HASPLOT ISNULL OR C.PLOT_IMAGE_SID NOTNULL) AND 
        (F.ISROOTOBJECT ISNULL OR C.PARENT_CARD_SID ISNULL) AND
        (F.ISNOTROOTOBJECT ISNULL OR C.PARENT_CARD_SID NOTNULL) AND
        (F.TYPE_SID ISNULL OR F.TYPE_SID IN (SELECT TYPE_SID FROM CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=C.SID)) AND
        (F.CHRONOLOGY_SID ISNULL OR F.CHRONOLOGY_SID IN (SELECT CHRONOLOGY_SID FROM CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=C.SID)) AND
        (F.FACILITY_SID ISNULL OR F.FACILITY_SID IN (SELECT FACILITY_SID FROM CARD_FACILITY_REL WHERE CARD_SID=C.SID)) AND
        (F.FINDING_SID ISNULL OR F.FINDING_SID IN (SELECT FINDING_SID FROM CARD_FINDING_REL WHERE CARD_SID=C.SID)) AND
        (F.HASIMAGES ISNULL OR EXISTS (SELECT TARGET_SID FROM RELATION WHERE OBJECT_SID=C.SID AND OBJECT_TYPE='IMAGE')) AND
        (F.HASFILES ISNULL OR EXISTS (SELECT TARGET_SID FROM RELATION WHERE OBJECT_SID=C.SID AND OBJECT_TYPE='FILE')) AND
        (F.COMPLETED ISNULL OR C.COMPLETED);
