<%
    ' Filter editing
    Class UCFilter ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
        '   TO DO: Declare control/user control variables for contained controls e.g.
            Private btnOk, btnCancel, btnDelete, btnAdd
            Private lstOwnership, lstTerrainUsage, 
            
            
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set ctlLocation = Create_UCLocationReadOnly(Empty)
            ctlLocation.AsyncPostBack(ctlLocation) = True
            ctlLocation.Nomenclature = "LOCATION"
            ctlLocation.Width = 400
            ctlLocation.Height = 200
            
            ' Nomenclatures
            Set lstOwnership = SimpleNomenclatureListBox("OWNERSHIP")
            Set lstTerrainUsage = SimpleNomenclatureListBox("TERRAINUSAGE")
            Set ctlGeoForm = TreeNomenclatureSelector("GEOFORM")
            Set ctlOrography = TreeNomenclatureSelector("OROGRAPHY")
            Set ctlHydrography = TreeNomenclatureSelector("HYDROGRAPHY")
            Set ctlSoilType = TreeNomenclatureSelector("SOIL_TYPE")
            Set lstExposition = SimpleNomenclatureListBox("EXPOSITION")
            Set lstAccessibility = SimpleNomenclatureListBox("ACCESSIBILITY")
            Set lstObservability = SimpleNomenclatureListBox("OBSERVABILITY")
            Set lstSlope = SimpleNomenclatureListBox("SLOPE")
            Set lstConcentration = SimpleNomenclatureListBox("CONCENTRATION")
            Set lstGrouping = SimpleNomenclatureListBox("GROUPING")
            Set ctlFacility = TreeNomenclatureSelector("FACILITY")
            Set ctlFinding = TreeNomenclatureSelector("FINDING")
            Set ctlType = TreeNomenclatureSelector("TYPE")
            Set ctlChronology = TreeNomenclatureSelector("CHRONOLOGY")
            Set lstImportance = SimpleNomenclatureListBox("PROTECTION")
            Set lstImportance = SimpleNomenclatureListBox("IMPORTANCE")
            Set lstGuard = SimpleNomenclatureListBox("GUARD")
            Set lstEnvironment = SimpleNomenclatureListBox("ENVIRONMENT")
            Set lstPreservation = SimpleNomenclatureListBox("PRESERVATION")
            Set lstSocialization = SimpleNomenclatureListBox("SOCIALIZATION")
            Set lstUsageRegime = SimpleNomenclatureListBox("USAGEREGIME")
            
            Set person = Create_UCPerson(Empty)
            
            Set ckCompleted = Create_CCheckBox(Empty)
            ckCompleted.Caption = TR("Completed")
            
            Set ckCompleted = Create_CCheckBox(Empty)
            ckCompleted.Caption = TR("Completed")
            
            Set ckHasMap = Create_CCheckBox(Empty)
            ckHasMap.Caption = TR("Has map image")
            Set ckHasPlot = Create_CCheckBox(Empty)
            ckHasPlot.Caption = TR("Has plot image")
            Set ckHasImages = Create_CCheckBox(Empty)
            ckHasImages.Caption = TR("Has images attached")
            
            
            
            
            
            ' Buttons
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.AsyncPostBack(Me) = True
            btnDelete.ConfirmationText = TR("Do you really want to remove this filter?")
            
            Set btnAddNew = Create_CButton(Empty)
            btnAddNew.Caption = TR("Create new filter")
            btnAddNew.AsyncPostBack(Me) = True
            
            
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        ' SESSION Preferences
        ' TO DO: If you do not need session preferences you can remove the 3 members below
        '   Call SavePrefs in the Render phase - as late as possible
        '   Call LoadPrefs in ProcessPage or from outside when the control shows for the first time. Note that choosing the right conditions may be tricky
        '       depending on the way the application is designed. Check the documentation for a discussion on how to find the right conditions.
        Public Sub InitSessionPreferences(vars)
            ' TO DO: Set initial values for the session preferences used by this control
            '   example:
            '   vars("myparam") = "hello"
        End Sub
        Public Sub SavePrefs
            ' TO DO: save the values of the session preferences
            '   example:
            '   SessionPreferences.SetCtlVar Me, "myparam", txtTextBox1.Value
            '   ' A session preference may correspond to a value of a contained control, internal variable or a property
            '   ' In this routine you must fetch it and pass it to the SessionPreferences global singleton class for safekeeping
        End Sub
        Public Sub LoadPrefs
            ' TO DO: Recover the values of the session preferences 
            '   example:
            '   txtTextBox1.Value = ConvertTo(vbString,SessionPreferences.GetCtlVar(Me, "myparam"))
            '   ' When restoring the session preferences you must assign them to their roles inside the control.
            '   ' They may correspond to a value of a contained control (like the example line above), a variable, a property or they
            '   ' can even be only a base over which more than one values are calculated - this is up to you.
        End Sub
        
        Sub ProcessPage
            ' TO DO: If you are using advanced features like session preferences or PreserveInQueryString it is a good idea
            '   to implement them before writing the bulk of the processing code. This can be done in a separate method called at this point
            '   or in-place - choice is entirely a matter of taste.
            '
            '   example: Load session preferences assuming the control is never hidden. For more complicated scenarios see the discussion in the documentation
            '   If Not IsPostBack Then LoadPrefs
            
        
            ' TO DO: Implement the page processing here the same way as int he ProcessPage of a regular ASP-CTL page
            '   How to determine the request type - if needed
            '   If IsPostBack Then ' A form post or async post back
            '       If IsPartialRequest Then ' An async (partial page rendering) request
            '       End If
            '   Else ' Get request
            '   End If
        End Sub
        
        ' POST VARIABLES
        '   TO DO: Implement properties that save values in the post variables
            ' Simple example (assume you want to store/restore a long value):
            ' Public Property Get MyProperty
            '    MyProperty = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"MyVar"))
            ' End Property
            ' Public Property Let MyProperty(v)
            '    PostVariables.SetCtlVar Me, "MyVar", ConvertTo(vbLong,v)
            ' End Property
        
            ' More complex example - a collection of values in the post variables
            ' Public Property Get MyCollection
            '    Set MyCollection = PostVariables.CtlPostCollection(Me,"MyColl")
            ' End Property
        ' Frequently used properties
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            ' TO DO: If you want to attach validators to this user control this property will be used by all the standard validator procedures
            '   return whatever is appropriate for validation. For example if this control enables the user to select something and you want to attach
            '   a "required validator" you need to return Empty when nothing is selected and something else (a database Id of the item for example) otherwise.
            '   While the Value is not declared as default (to leave the option usable for other purposes) it is intended for library usage. It may be needed
            '   for future functionality enhancements - be careful to implement it as described.
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCFilter" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            ' TO DO: Render the inner content of the control including any contained controls.
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCFilter(ctlName) 
        Set ctl = New UCFilter ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCFilter = ctl ' TO DO: Change the control name
    End Function

%>