<%
    Const HintWindowWidth = 350
    Const HintWindowHeight = 350
    
    Class UCHint
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' TO DO: Declare control/user control variables e.g.
        ' Private txtBox1, btnOk, myUserControl
        
        ' TO DO: Declare indicator properties e.g.
        ' Public Changed
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Class_Initialize
                        
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            ClientScripts.Block("UCHint") = "var ccHintBase='" & VirtPath("/") & "';var ccHintId='" & ClientId & _
                                            "'; ccHintWindowWidth=" & HintWindowWidth & ";ccHintWindowHeight=" & HintWindowHeight & ";" & vbCrLf
            ClientScripts.RegisterFile "/usercontrols/uc-hint.js", VirtPath("/usercontrols/uc-hint.js")
            
            CssClass = "hintbox"
            
        End Sub
        
        Sub ProcessPage
            ' TO DO: Implement the page processing here the same way as int he ProcessPage of a regular ASP-CTL page
        End Sub
        
        Public Function Hint(target,key)
            ClientScripts.RegisterEventHandler target, "click", "ccStaticShowHint", "'" & key & "'", "UCHint"
        End Function
        
        Public Property Get Value
            Value = Id
            If Id = 0 Then Value = Empty
        End Property
        
        Public Property Get ClassType
            ClassType = "UCHint" 
        End Property
        
        Public Sub RenderHint(hKey)
            Exit Sub
            %>
            <img style="cursor: pointer;" src="<%= VirtPath("/img/hint.png") %>" width="16" height="16" <% ClientScripts.RenderSingleEventHandler "ccStaticShowHint2","click","'" & hKey & "'" %> />
            <%
        End Sub
        
        Public Sub Render
        ' TO DO: Render the control
            %>
            <div id="<%= ClientId %>" class="<%= CssClass %>">
                <table class="hintTable" cellpadding="0" cellspacing="0">
                    <tr>
                        <td width="100%" colspan="3" valign="top"><img src="<%= VirtPath("/img/hint-back-topw.png") %>" alt="" width="<%= HintWindowWidth %>" height="10" /></td>
                    </tr>
                    <tr>
                        <td width="100%" colspan="3" valign="top" class="hintInsidew">
                            <table class="hintContent" cellpadding="0" cellspacing="0">
                                <tr>
                                    <th nowrap ><img src="<%= VirtPath("/img/hint-close.png") %>" alt="<%= TR("Close hint") %>" style="cursor: pointer;"
                                        width="16" height="16" onclick="ccStaticHideHint()" /></th>
                                    <th nowrap><span style="cursor: pointer;" onclick="ccStaticHideHint()"><%= TR("Close") %></span></th>
                                    <th width="100%" align="right" style="text-align:right;width:100%;"><%= TR("Quick help") %></th>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td width="100%" colspan="3" valign="top" class="hintInside">
                            <table class="hintContent" cellpadding="0" cellspacing="0">
                                <tr>
                                    <td width="100%" colspan="3" valign="top"><div id="<%= ClientId & "_Content" %>" class="hintBody"></div></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td width="100%" colspan="3" valign="top"><img src="<%= VirtPath("/img/hint-back-bottom.png") %>" alt="" width="350" height="10" /></td>
                    </tr>
                </table>
                
                
                
            </div>
            <%
        End Sub
    
    End Class

    

%>