<%
    Class UCUserServices ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        Public IsGroup
        Public ShowRemove
        
        ' CONTROLS
           Private colFields
           Private btnSave, btnOpen, btnClose, btnRemove
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            ' INIT CONTAINED USER CONTROLS
            '   TO DO: Initialize any user controls contained in this control e.g.
            '   Set myUserControl = New UCMyUserControl
            '   myUserControl.SomeProperty = Something
            ' INIT CONTAINED WEB CONTROLS
            Dim arrF, arrL, f, I
            arrF = Split(UCServices_Fields,",")
            arrL = Split(UCServices_Labels,",")
            Set colFields = CreateCollection
            For I = LBound(arrF) To UBound(arrF)
                Set f = Create_CCheckBox(Empty)
                f.Caption = TR(arrL(I))
                Set colFields(arrF(I)) = f
            Next
                        
            Set btnSave = Create_CButton(Empty)
            btnSave.Caption = TR("Save")
            btnSave.SkinId = "Green"
            btnSave.AsyncPostBack(Me) = True
            Set btnRemove = Create_CButton(Empty)
            btnRemove.Caption = TR("Remove")
            btnRemove.SkinId = "Red"
            btnRemove.AsyncPostBack(Me) = True
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            CssClass = "UCUserServices"
            
        End Sub
        
        ' SESSION Preferences
        ' TO DO: If you do not need session preferences you can remove the 3 members below
        '   Call SavePrefs in the Render phase - as late as possible
        '   Call LoadPrefs in ProcessPage or from outside when the control shows for the first time. Note that choosing the right conditions may be tricky
        '       depending on the way the application is designed. Check the documentation for a discussion on how to find the right conditions.
        Public Sub InitSessionPreferences(vars)
            ' TO DO: Set initial values for the session preferences used by this control
            '   example:
            '   vars("myparam") = "hello"
        End Sub
        Public Sub SavePrefs
            ' TO DO: save the values of the session preferences
            '   example:
            '   SessionPreferences.SetCtlVar Me, "myparam", txtTextBox1.Value
            '   ' A session preference may correspond to a value of a contained control, internal variable or a property
            '   ' In this routine you must fetch it and pass it to the SessionPreferences global singleton class for safekeeping
        End Sub
        Public Sub LoadPrefs
            ' TO DO: Recover the values of the session preferences 
            '   example:
            '   txtTextBox1.Value = ConvertTo(vbString,SessionPreferences.GetCtlVar(Me, "myparam"))
            '   ' When restoring the session preferences you must assign them to their roles inside the control.
            '   ' They may correspond to a value of a contained control (like the example line above), a variable, a property or they
            '   ' can even be only a base over which more than one values are calculated - this is up to you.
        End Sub
        
        Public Function Load(uid)
            Dim r, I
            Load = False
            If IsGroup Then
                Set r = Database.DB.VExecute("SELECT * FROM GROUP_SERVICES WHERE GROUP_ID=$GROUP_ID",1,1,NullConvertTo(vbLong, uid))
            Else
                Set r = Database.DB.VExecute("SELECT * FROM USER_SERVICES WHERE USER_ID=$USER_ID",1,1,NullConvertTo(vbLong, uid))
            End If
            Id = uid
            If r.Count > 0 Then
                Set r = r(1)
                For I = 1 To colFields.Count
                    colFields(I).Checked = ConvertTo(vbBoolean,r(colFields.Key(I)))
                Next
                Load = True
            Else
                For I = 1 To colFields.Count
                    colFields(I).Checked = False
                Next
            End If
        End Function
        Public Function Save
            Dim params
            Save = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Set params = CreateCollection
                    params.Missing = Null
                    For I = 1 To colFields.Count
                        params(colFields.Key(I)) = ConvertTo(vbLong, colFields(I).Checked)
                    Next
                    If IsGroup Then
                        params("GROUP_ID") = Id
                        Database.DB.CExecute "INSERT INTO GROUP_SERVICES (GROUP_ID," & CreateSQLParameterList(colFields) & _
                                                ") VALUES ($GROUP_ID," & CreateSQLValuesList(colFields) & ")", params
                    Else
                        params("USER_ID") = Id
                        Database.DB.CExecute "INSERT INTO USER_SERVICES (USER_ID," & CreateSQLParameterList(colFields) & _
                                                ") VALUES ($USER_ID," & CreateSQLValuesList(colFields) & ")", params
                    End If
                    
                    If Database.CompleteTransaction Then
                        Save = True
                    End If
                End If
            End If
        End Function
        Public Function Remove
            Dim tbl
            Remove = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    If IsGroup Then tbl = "GROUP_SERVICES" Else tbl = "USER_SERVICES"
                    Database.DB.VExecute "DELETE FROM " & tbl & " WHERE " & IfThenElse(IsGroup,"GROUP_ID","USER_ID") & "=$ID", 1, 0, Id
                    If Database.CompleteTransaction Then
                        Remove = True
                    End If
                End If
            End If
        End Function
        
        Sub ProcessPage
            If IsPostBack Then ' A form post or async post back
                If btnSave.Clicked Then
                    If Save Then
                        Active = False
                    End If
                ElseIf btnRemove.Clicked Then
                    If Remove Then Active = False
                ElseIf btnOpen.Clicked Or btnClose.Clicked Then
                    If Active Then
                        Active = False
                    Else
                        Loaded = Load(Id)
                        
                        Active = True
                    End If
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"U"))
        End Property
        Public Property Let Id(v)
           Dim n
           n = ConvertTo(vbLong,v)
           PostVariables.SetCtlVar Me, "U", n
           Active = False
        End Property
        Public Property Get Loaded
            Loaded = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"L"))
        End Property
        Public Property Let Loaded(v)
            PostVariables.SetCtlVar Me, "L", ConvertTo(vbBoolean,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
            ' More complex example - a collection of values in the post variables
            ' Public Property Get MyCollection
            '    Set MyCollection = PostVariables.CtlPostCollection(Me,"MyColl")
            ' End Property
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCUserServices" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            If Id <> 0 Then
                If Active Then
                    RenderSlim
                    RenderForm
                Else
                    RenderSlim
                End If
            End If
        End Sub
        
        Private Sub RenderSlim
            Dim sbarClass
            If Active Then sbarClass = "SelectorBarActive" Else sbarClass = "SelectorBar"
            %>
            <table class="<%= sbarClass %>" >
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <td nowrap style="width: 100%;cursor:pointer;" onclick="<%= IfThenElse(Mode > 0,btnClose.GetAsyncPostBack(Me,0),btnOpen.GetAsyncPostBack(Me,0)) %>"><%= TR("Edit user services") %></td>
                    <td nowrap><% 
                        If Not Active Then
                            btnOpen.Render
                        Else
                            btnClose.Render
                        End If
                    %></td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderForm
            Dim I
            %>
            <table class="form" >
                <tr>
                    <th nowrap class="formCaption" colspan="2"><%= TR("User services") %></th>
                </tr>
                <tr>
                    <td class="formField" colspan="2">
                        <% 
                            For I = 1 To colFields.Count
                                colFields(I).Render
                                Response.Write "<br/>"
                            Next
                        %>
                    </td>
                </tr>
                <tr>
                    <td colspan="2" class="formButtons">
                        <%
                            btnSave.Render
                            If ShowRemove And Loaded Then btnRemove.Render
                        %>
                    </th>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCUserServices(ctlName) 
        Set ctl = New UCUserServices ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCUserServices = ctl ' TO DO: Change the control name
    End Function

%>