<!-- #include file="ucadm-translations.asp" -->
<%

    Class UCAdmLanguages ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' Not currently used - will be removed from the template in future versions
        Public CssClass
        Public Style
        Public SkinId
        Private pListTableCssClass
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
        Private txtLanguage, txtName, txtNameNative
        Private vldLanguage, vldLanguageFilter, vldName, vldNameFilter, vldNameNative, vldNameNativeFilter
        Private txtEncoding, txtCodePage, txtDateFormat, txtTimeFormat
        Private vldEncoding, vldEncodingFilter, vldCodePage, vldCodePageFilter, vldDateFormat, vldTimeFormat
        Private txtDateTimeFormat, vldDateTimeFormat, fileIconBox, ckRemoveImage
        Private btnEdit, btnNew, btnDel, btnOk, btnCancel, btnReload, pager, orderer, lstLanguages, btnChangeLanguage
        Private btnTrans, cTrans
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Class_Initialize
            Set cTrans = New UCAdmTranslations
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False ' No longer required - about to be deprecated
            
            Set txtLanguage = Create_CText(Empty)
            txtLanguage.MaxLength = 10
            txtLanguage.Style = "width: 100%"
            Set vldLanguage = Create_CValidatorFor(Empty,txtLanguage,"ValidateRequired,ValidateLength,ValidateRegExp")
            vldLanguage.Required = True
            vldLanguage.MinLength = 2
            vldLanguage.MaxLength = 10
            vldLanguage.RegExpression = "^[a-z]{2}(\-[a-z]{2}){0,1}$"
            vldLanguage.Group = Me.Name & "New"
            Set vldLanguageFilter = vldLanguage.Clone
            vldLanguageFilter.Required = False
            vldLanguageFilter.Group = Me.Name & "Filter"
            
            Set txtName = Create_CText(Empty)
            txtName.MaxLength = 64
            txtName.Style = "width: 100%"
            Set vldName = Create_CValidatorFor(Empty,txtName,"ValidateRequired,ValidateLength,ValidateRegExp")
            vldName.Required = True
            vldName.MinLength = 1
            vldName.MaxLength = 64
            vldName.RegExpression = "^[a-zA-Z0-9 \-\/\(\)]+$"
            vldName.Group = Me.Name & "Edit"
            Set vldNameFilter = vldName.Clone
            vldNameFilter.Required = False
            vldNameFilter.Group = Me.Name & "Filter"
            
            Set txtNameNative = Create_CText(Empty)
            txtNameNative.MaxLength = 64
            txtNameNative.Style = "width: 100%"
            Set vldNameNative = Create_CValidatorFor(Empty,txtName,"ValidateRequired,ValidateLength")
            vldNameNative.Required = False
            vldNameNative.MinLength = 1
            vldNameNative.MaxLength = 64
            vldNameNative.Group = Me.Name & "Edit"
            Set vldNameNativeFilter = vldNameNative.Clone
            vldNameNativeFilter.Required = False
            vldNameNativeFilter.Group = Me.Name & "Filter"
            
            Set txtEncoding = Create_CText(Empty)
            txtEncoding.MaxLength = 64
            txtEncoding.Style = "width: 100%"
            Set vldEncoding = Create_CValidatorFor(Empty,txtEncoding,"ValidateRequired,ValidateLength,ValidateRegExp")
            vldEncoding.Required = True
            vldEncoding.MinLength = 1
            vldEncoding.MaxLength = 32
            vldEncoding.RegExpression = "^[a-zA-Z0-9\-\_\.]+$"
            vldEncoding.Group = Me.Name & "Edit"
            Set vldEncodingFilter = vldEncoding.Clone
            vldEncodingFilter.Required = False
            vldEncodingFilter.Group = Me.Name & "Filter"
            
            Set txtCodePage = Create_CText(Empty)
            txtCodePage.MaxLength = 6
            txtCodePage.Style = "width: 100%"
            Set vldCodePage = Create_CValidatorFor(Empty,txtCodePage,"ValidateRequired,ValidateType,ValidateRange")
            vldCodePage.Required = True
            vldCodePage.MinValue = -1
            vldCodePage.MaxValue = 100000
            vldCodePage.ValType = vbLong
            vldCodePage.Group = Me.Name & "Edit"
            Set vldCodePageFilter = vldCodePage.Clone
            vldCodePageFilter.Required = False
            vldCodePageFilter.Group = Me.Name & "Filter"
            
            Set txtDateFormat = Create_CText(Empty)
            txtDateFormat.MaxLength = 32
            txtDateFormat.Style = "width: 100%"
            Set vldDateFormat = Create_CValidatorFor(Empty,txtDateFormat,"ValidateRequired,ValidateLength,ValidateRegExp")
            vldDateFormat.Required = True
            vldDateFormat.MinLength = 6
            vldDateFormat.MaxLength = 32
            vldDateFormat.Group = Me.Name & "Edit"
            
            Set txtTimeFormat = Create_CText(Empty)
            txtTimeFormat.MaxLength = 32
            txtTimeFormat.Style = "width: 100%"
            Set vldTimeFormat = Create_CValidatorFor(Empty,txtTimeFormat,"ValidateRequired,ValidateLength,ValidateRegExp")
            vldTimeFormat.Required = True
            vldTimeFormat.MinLength = 2
            vldTimeFormat.MaxLength = 32
            vldTimeFormat.Group = Me.Name & "Edit"
            
            Set txtDateTimeFormat = Create_CText(Empty)
            txtDateTimeFormat.MaxLength = 32
            txtDateTimeFormat.Style = "width: 100%"
            Set vldDateTimeFormat = Create_CValidatorFor(Empty,txtDateTimeFormat,"ValidateRequired,ValidateLength,ValidateRegExp")
            vldDateTimeFormat.Required = True
            vldDateTimeFormat.MinLength = 6
            vldDateTimeFormat.MaxLength = 32
            vldDateTimeFormat.Group = Me.Name & "Edit"
            
            Set fileIconBox = Create_CFile(Empty)
            
            Set ckRemoveImage = Create_CCheckBox(Empty)
            ckRemoveImage.Caption = TR("Remove the icon image")
            
            Set btnEdit = Create_CButton(Empty)
            btnEdit.Caption = TR("Edit")
            Set btnNew = Create_CButton(Empty)
            btnNew.Caption = TR("Add new language")
            Set btnDel = Create_CButton(Empty)
            btnDel.ConfirmationText = "Do you really want to remove this language settings?"
            btnDel.Caption = TR("Delete")
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            Set btnReload = Create_CButton(Empty)
            btnReload.Caption = TR("Reload")
            
            Set btnTrans = Create_CButton(Empty)
            
            Set pager = Create_ButtonPager(Empty)
            Set orderer = Create_OrdererSet(Empty)
            orderer.ShowLabels = True
            orderer("LANGUAGE").Caption = TR("Language")
            orderer("NAME").Caption = TR("Name")
            orderer("NAMENATIVE").Caption = TR("Native name")
            orderer("ENCODING").Caption = TR("Encoding")
            orderer("CODEPAGE").Caption = TR("Code page")
            
            Set lstLanguages = Create_CList(Empty)
            lstLanguages.AddSQLiteItems ASPCTLResDB.Execute("SELECT LANGUAGE, NAME || ' (' || LANGUAGE || ')' AS NAME FROM Languages ORDER BY NAME ASC"), "LANGUAGE", "NAME"
            Set btnChangeLanguage = Create_CButton(Empty)
            btnChangeLanguage.Caption = TR("Change language")
            
            ListTableCssClass = "UCSimpleGrid" ' Because this one is frequently used we can usually piggyback ...
            
        End Sub
        
        Sub ClearFields
            txtLanguage.Value = ""
            txtName.Value = ""
            txtNameNative.Value = ""
            txtEncoding.Value = ""
            txtCodePage.Value = ""
            txtDateFormat.Value = ""
            txtTimeFormat.Value = ""
            txtDateTimeFormat.Value = ""
        End Sub
        
        Sub ProcessPage
            Dim filter, r, lang
            If IsPostBack Then
                If btnTrans.Clicked Then
                    Translations = Not Translations
                    If Translations Then
                        cTrans.LoadTable
                    End If
                ElseIf btnOk.Clicked Then
                    If (AddingLanguage And Validate("Edit,New")) Or (Not AddingLanguage And Validate("Edit")) Then
                        If AddingLanguage Then 
                            lang = ConvertTo(vbString,txtLanguage.Value) 
                        Else
                            lang = CurrentLanguage
                        End If
                        
                        If fileIconBox.IsUploaded Then
                            ASPCTLResDB.VExecute "INSERT INTO Languages (LANGUAGE,NAME,NAMENATIVE,ENCODING,CODEPAGE,DATEFORMAT,TIMEFORMAT,DATETIMEFORMAT,ICON) VALUES ($lang,$name,$namenative,$enc,$cp,$df,$tf,$dtf,$icon)", 1, 0, _
                                                    lang, _
                                                    NullConvertTo(vbString,txtName.Value), _
                                                    NullConvertTo(vbString,txtNameNative.Value), _
                                                    NullConvertTo(vbString,txtEncoding.Value), _
                                                    NullConvertTo(vbLong,txtCodePage.Value), _
                                                    NullConvertTo(vbString,txtDateFormat.Value), _
                                                    NullConvertTo(vbString,txtTimeFormat.Value), _
                                                    NullConvertTo(vbString,txtDateTimeFormat.Value), _
                                                    fileIconBox.Data
                        Else
                            ASPCTLResDB.VExecute "INSERT INTO Languages (LANGUAGE,NAME,NAMENATIVE,ENCODING,CODEPAGE,DATEFORMAT,TIMEFORMAT,DATETIMEFORMAT) VALUES ($lang,$name,$namenative,$enc,$cp,$df,$tf,$dtf)", 1, 0, _
                                                    lang, _
                                                    NullConvertTo(vbString,txtName.Value), _
                                                    NullConvertTo(vbString,txtNameNative.Value), _
                                                    NullConvertTo(vbString,txtEncoding.Value), _
                                                    NullConvertTo(vbLong,txtCodePage.Value), _
                                                    NullConvertTo(vbString,txtDateFormat.Value), _
                                                    NullConvertTo(vbString,txtTimeFormat.Value), _
                                                    NullConvertTo(vbString,txtDateTimeFormat.Value)
                                                    
                        End If
                        AddingLanguage = False
                        CurrentLanguage = ""
                        ClearFields
                    End If            
                ElseIf btnCancel.Clicked Then
                    ClearFields    
                    AddingLanguage = False
                    CurrentLanguage = ""
                ElseIf btnEdit.Clicked Then
                    Set r = ASPCTLResDB.VExecute("SELECT * FROM Languages WHERE Language=$lang", 1, 1, NullConvertTo(vbString,btnEdit.Value))
                    If r.Count > 0 Then
                        txtLanguage.Value = ConvertTo(vbString,r(1)("LANGUAGE"))
                        txtName.Value = ConvertTo(vbString,r(1)("NAME"))
                        txtNameNative.Value = ConvertTo(vbString,r(1)("NAMENATIVE"))
                        txtEncoding.Value = ConvertTo(vbString,r(1)("ENCODING"))
                        txtCodePage.Value = ConvertTo(vbLong,r(1)("CODEPAGE"))
                        txtDateFormat.Value = ConvertTo(vbString,r(1)("DATEFORMAT"))
                        txtTimeFormat.Value = ConvertTo(vbString,r(1)("TIMEFORMAT"))
                        txtDateTimeFormat.Value = ConvertTo(vbString,r(1)("DATETIMEFORMAT"))
                        AddingLanguage = False
                        CurrentLanguage = r(1)("LANGUAGE")
                        HasImage = Not IsNull(r(1)("ICON"))
                    End If
                ElseIf btnNew.Clicked Then
                    ClearFields
                    AddingLanguage = True
                    CurrentLanguage = ""
                    HasImage = False
                ElseIf btnDel.Clicked Then
                    ASPCTLResDB.VExecute "DELETE FROM Languages WHERE LANGUAGE=$lang", 1, 0, NullConvertTo(vbString,btnDel.Value)
                    AddingLanguage = False
                    CurrentLanguage = ""
                ElseIf btnChangeLanguage.Clicked Then
                    SetSessionLanguage lstLanguages.SelectedValue
                    MasterCancelProcessing = True
                    Response.Redirect Self
                    Exit Sub
                End If
            Else ' Not IsPostBack
                lstLanguages.SelectedValue = PageUILanguage
            End If            
            
            If Translations Then
                btnTrans.Caption = TR("Edit the supported languages")
            Else
                btnTrans.Caption = TR("Edit the string translations")
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Translations
            Translations = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"T"))
        End Property
        Public Property Let Translations(v)
            PostVariables.SetCtlVar Me, "T", ConvertTo(vbBoolean,v)
        End Property
        Public Property Get AddingLanguage
            AddingLanguage = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let AddingLanguage(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        Public Property Get HasImage
            HasImage = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let HasImage(v)
            PostVariables.SetCtlVar Me, "I", ConvertTo(vbBoolean,v)
        End Property
        Public Property Get CurrentLanguage
            CurrentLanguage = ConvertTo(vbString,PostVariables.GetCtlVar(Me,"C"))
        End Property
        Public Property Let CurrentLanguage(v)
            PostVariables.SetCtlVar Me, "C", ConvertTo(vbString,v)
        End Property
        
        Public Property Get ListTableCssClass
            ListTableCssClass = pListTableCssClass
        End Property
        Public Property Let ListTableCssClass(v)
            pListTableCssClass = v
            cTrans.ListTableCssClass = v
        End Property
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCAdmLanguages" 
        End Property
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <%
                    Response.Write TR("Current language") : lstLanguages.Render : btnChangeLanguage.Render
                    btnTrans.Render
                    If Translations Then
                        cTrans.Render
                    Else
                        RenderLangs
                    End If
                %>
            </div>
            <%
        End Sub
        
        Public Sub RenderLangs
            Dim nRec, rec, results, filter, rowCss
            
            If Not AddingLanguage And CurrentLanguage = "" Then
                
                Validate "Filter"
                
                filter =    " ($lang ISNULL OR $lang=LANGUAGE) AND " & _
                            " ($name ISNULL OR $name=NAME) AND " & _
                            " ($namenative ISNULL OR $namenative=NAMENATIVE) AND " & _
                            " ($enc ISNULL OR $enc=ENCODING) AND " & _
                            " ($cp ISNULL OR $cp=CODEPAGE) "
                
                pager.ItemCount = ASPCTLResDB.VExecute("SELECT COUNT(*) FROM Languages WHERE " & filter, 1,1, _
                                                        NullConvertTo(vbString,txtLanguage.Value), _
                                                        NullConvertTo(vbString,txtName.Value), _
                                                        NullConvertTo(vbString,txtNameNative.Value), _
                                                        NullConvertTo(vbString,txtEncoding.Value), _
                                                        NullConvertTo(vbLong,txtCodePage.Value))(1)(1)
                Set results = ASPCTLResDB.VExecute("SELECT * FROM Languages WHERE " & filter & orderer.OrderClause,1 + (pager.Page - 1) * pager.PageSize, pager.PageSize, _
                                                        NullConvertTo(vbString,txtLanguage.Value), _
                                                        NullConvertTo(vbString,txtName.Value), _
                                                        NullConvertTo(vbString,txtNameNative.Value), _
                                                        NullConvertTo(vbString,txtEncoding.Value), _
                                                        NullConvertTo(vbLong,txtCodePage.Value))
                
            %>
                <h4>Languages</h4>
                <% btnNew.Render %>
                <table class="<%= ListTableCssClass %>" width="100%" style="width:100%">
                    <tr class="heading">
                        <th>&nbsp;</th>
                        <th><% orderer("LANGUAGE").Render : vldCodePageFilter.Render %></th>
                        <th><% orderer("NAME").Render : vldNameFilter.Render %></th>
                        <th><% orderer("NAMENATIVE").Render : vldNameNativeFilter.Render %></th>
                        <th><% orderer("ENCODING").Render : vldEncodingFilter.Render %></th>
                        <th><% orderer("CODEPAGE").Render : vldCodePageFilter.Render %></th>
                        <th>&nbsp;</th>
                    </tr>
                    <tr class="filter">
                        <th>&nbsp;</th>
                        <th><% txtLanguage.Render %></th>
                        <th><% txtName.Render %></th>
                        <th><% txtNameNative.Render %></th>
                        <th><% txtEncoding.Render %></th>
                        <th><% txtCodePage.Render %></th>
                        <th><% btnReload.Render %></th>
                    </tr>
                    <%
                    For nRec = 1 To results.Count
                        Set rec = results(nRec)
                        If nRec Mod 2 = 0 Then rowCss = "even" Else rowCss = "odd"
                        %>
                        <tr class="<%= rowCss %>">
                            <td>
                                <%
                                    If IsNull(rec("ICON")) Then
                                        Response.Write "&nbsp;"
                                    Else
                                        %><img src="<%= LanguageIcon(rec("Language")) %>" /><%
                                    End If
                                %>
                            </td>
                            <td><%= HTMLEncode(rec("LANGUAGE")) %></td>
                            <td><%= HTMLEncode(rec("NAME")) %></td>
                            <td><%= HTMLEncode(rec("NAMENATIVE")) %></td>
                            <td><%= HTMLEncode(rec("ENCODING")) %></td>
                            <td><%= HTMLEncode(rec("CODEPAGE")) %></td>
                            <td><% btnEdit.RenderValue(ConvertTo(vbString,rec("LANGUAGE"))) : btnDel.RenderValue(ConvertTo(vbString,rec("LANGUAGE"))) %></td>
                        </tr>
                        <%
                    Next
                    %>
                    
                </table>
                <%
                pager.Render
                orderer.Render
            Else
                ' Render the edit or new form
                %>
                    <% If AddingLanguage Then %>
                        <h4>Add a language</h4>
                    <% Else %>
                        <h4>Edit a language</h4>
                    <% End If %>
                    <table class="<%= ListTableCssClass %>">
                        <tr>
                            <td><%= TR("Language") %></td>
                            <td nowrap>
                                <% If AddingLanguage Then
                                        txtLanguage.Render
                                        vldLanguage.Render
                                   Else
                                        Response.Write CurrentLanguage
                                   End If %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Name") %></td>
                            <td nowrap>
                                <% txtName.Render : vldName.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Native name") %></td>
                            <td nowrap>
                                <% txtNameNative.Render : vldNameNative.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Encoding") %></td>
                            <td nowrap>
                                <% txtEncoding.Render : vldEncoding.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Code page") %></td>
                            <td nowrap>
                                <% txtCodePage.Render : vldCodePage.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Date format") %></td>
                            <td nowrap>
                                <% txtDateFormat.Render : vldDateFormat.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Time format") %></td>
                            <td nowrap>
                                <% txtTimeFormat.Render : vldTimeFormat.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Date/Time format") %></td>
                            <td nowrap>
                                <% txtDateTimeFormat.Render : vldDateTimeFormat.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Icon") %></td>
                            <td>
                                <% 
                                If HasImage Then
                                    %><img src="<%= LanguageIcon(CurrentLanguage) %>" /><%
                                    ckRemoveImage.Render
                                Else
                                    Response.Write TR("No icon")
                                End If
                                %>
                            </td>
                        </tr>
                        <tr>
                            <td><%= TR("Set/change icon") %></td>
                            <td>
                                <% fileIconBox.Render %>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">
                                <% btnOk.Render : btnCancel.Render %>
                            </td>
                        </tr>
                    </table>
                    <%            
                End If
        End Sub
    
    End Class

%>