<%
    ' For the current user
    Class UCProfileShowQuotas ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
            
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            
            
            
            CssClass = "UCProfileShowQuotas"
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        Sub ProcessPage
            
        End Sub
        
        
        Public Property Get Value
            Value = Empty
        End Property
        
        Public Property Get ClassType
            ClassType = "UCProfileShowQuotas" 
        End Property
        
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% If IsLoggedOn Then RenderPartial %>
            </div>
            <%
        End Sub
        Private Sub RenderQuota(qname,qlabel,q,dq,dp)
            %>
            <tr>
                <th class="subcaption" colspan="3"><%= HTMLEncode(qlabel) %></th>
            </tr>
            <tr>
                <th class="label" colspan="3"><%= TR("Total quota") %></th>
            </tr>
            <tr>
                <td class="amount"><%= ConvertTo(vbLong, q) %></td>
                <td class="used"><% 
                    Response.Write ConvertTo(vbLong, q) - ConvertTo(vbLong, CurrentUser.GetEffectiveQuotaAvailable(qname,False))
                    If IsAdmin Then Response.Write " * "
                %></td>
                <td class="available"><%= ConvertTo(vbLong, CurrentUser.GetEffectiveQuotaAvailable(qname,False)) %></td>
            </tr>
            <tr>
                <th class="label" colspan="3"><%= StringUtilities.Sprintf(TR("Limit per %d day(s) period"),dp) %></th>
            </tr>
            <tr>
                <td class="amount"><%= ConvertTo(vbLong, dq) %></td>
                <td class="used"><%
                    Response.Write ConvertTo(vbLong, dq) - ConvertTo(vbLong, CurrentUser.GetEffectiveQuotaAvailable(qname,True))
                    If IsAdmin Then Response.Write " * "
                %></td>
                <td class="available"><%= ConvertTo(vbLong, CurrentUser.GetEffectiveQuotaAvailable(qname,True)) %></td>
            </tr>
            <%
        End Sub
        Public Sub RenderPartial
            Dim rQuota, rDeltaQuota, arrQFields, arrQLabels, r, I
            Set rQuota = Database.DB.Execute("SELECT * FROM USER_QUOTAS WHERE USER_ID=Parameter('USER_ID')",1,1)
            If rQuota.Count = 0 Then
                Set rQuota = Database.DB.Execute("SELECT * FROM GROUP_QUOTAS WHERE GROUP_ID=Parameter('GROUP_ID')",1,1)
            End If
            Set rDeltaQuota = Database.DB.Execute("SELECT * FROM USER_DELTA_QUOTAS WHERE USER_ID=Parameter('USER_ID')",1,1)
            If rDeltaQuota.Count = 0 Then
                Set rDeltaQuota = Database.DB.Execute("SELECT * FROM GROUP_DELTA_QUOTAS WHERE GROUP_ID=Parameter('GROUP_ID')",1,1)
            End If
            arrQFields = Split(UCQuotas_QFields,",")
            arrQLabels = Split(UCQuotas_QLabels,",")
            If rQuota.Count > 0 And rDeltaQuota.Count > 0 Then
            %>
            <table class="form" >
                <tr>
                    <th nowrap class="caption" colspan="3"><%= TR("Quota usage") %></th>
                </tr>
                <tr>
                    <th nowrap class="header"><%= TR("Quota") %></th>
                    <th nowrap class="header"><%= TR("Used") %></th>
                    <th nowrap class="header"><%= TR("Available") %></th>
                </tr>
                <%
                For I = LBound(arrQFields) To UBound(arrQFields)
                    RenderQuota arrQFields(I), arrQLabels(I), rQuota(1)(arrQFields(I)), rDeltaQuota(1)(arrQFields(I)), ConvertTo(vbLong, rQuota(1)("DAYS"))
                Next
                If IsAdmin Then
                %>
                <tr>
                    <td class="field" colspan="3">
                        * <%= TR("You are administrator and the above limitations do NOT apply.") %><br/>
                    </td>
                </tr>
                <% End If %>
            </table>
            <%
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCProfileShowQuotas(ctlName) 
        Set ctl = New UCProfileShowQuotas ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCProfileShowQuotas = ctl ' TO DO: Change the control name
    End Function

%>